package com.huimv.guowei.admin.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

/**
 * @Description: 注册验证tocken的拦截器
 * @Author
 * @Date 2021/4/19 20:41
 * @Version V1.0
 */
@Configuration
public class InterceptorConfig implements WebMvcConfigurer {
    @Bean
    public JWTInterceptor jwtInterceptor(){
        return new JWTInterceptor();
    }

  /*  @Override
    public void addInterceptors(InterceptorRegistry registry) {
        registry.addInterceptor(jwtInterceptor()).
                excludePathPatterns("/guoweiApi/admin/my/*")
                .excludePathPatterns("/guoweiApi/receive/feed","/guoweiApi/base-duck-info/printDuck","/guoweiApi/env-regular-call-egg/printEgg");
    }*/
    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        registry.addInterceptor(jwtInterceptor()).
                excludePathPatterns("/admin/my/*")
                .excludePathPatterns("/receive/feed","/base-duck-info/printDuck","/base-duck-info/printChi","/env-regular-call-egg/printEgg","/send/play","/energy-water/printWater","/energy-electricity/printElectricity",
                        "/admin/cameraArea/getUrl","/breed/importData","/duck-immunity-info/importData","/base-duck-info/importData"
                        ,"/duck-body-size-info/importData","/duck-egg-texture-info/importData","/group-duck-info/printDuckInfo");
    }
}
