package com.huimv.guowei.admin.controller;


import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.PdfUtil;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.common.utils.UploadImage;
import com.huimv.guowei.admin.entity.BaseDuckBreedImg;
import com.huimv.guowei.admin.entity.BaseDuckInfo;
import com.huimv.guowei.admin.service.IBaseDuckBreedImgService;
import com.huimv.guowei.admin.service.IBaseDuckInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.ParseException;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/base-duck-info")
@CrossOrigin
public class BaseDuckInfoController {

    @Autowired
    private IBaseDuckInfoService duckInfoService;


    @RequestMapping("/listDuck")
    public Result listDuck(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return duckInfoService.listDuck(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listAppDuck")
    public Result listAppDuck(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return duckInfoService.listAppDuck(httpServletRequest, paramsMap);
    }

    @RequestMapping("/deleteDuck")
    public Result deleteDuck(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        duckInfoService.removeById(paramsMap.get("id"));
        return new Result(10000, "删除成功！", true);
    }

    @PostMapping("/addDuck")
    public Result addDuck(HttpServletRequest httpServletRequest, @RequestParam(name = "imgUrl", required = false) MultipartFile imgUrl,
                          @RequestParam(name = "farmId") String farmId,
                          @RequestParam(name = "unitList",required = false) String unitList,
                          @RequestParam(name = "unitName",required = false) String unitName,
                          @RequestParam(name = "duckBreed") String duckBreed,
                          @RequestParam(name = "duckSex",required = false) String duckSex,
                          @RequestParam(name = "duckBirthPlace") String duckBirthPlace,
                          @RequestParam(name = "duckBirthDay") String duckBirthDay,
                          @RequestParam(name = "genotype") String genotype,
                          @RequestParam(name = "nowWeight") String nowWeight,
                          @RequestParam(name = "unitId",required = false) String unitId,
                          @RequestParam(name = "breedEnv",required = false) String breedEnv,
                          @RequestParam(name = "hatchRate", required = false) String hatchRate,
                          @RequestParam(name = "fatherNum", required = false) String fatherNum,
                          @RequestParam(name = "motherNum", required = false) String motherNum,
                          @RequestParam(name = "fatherGenotype") String fatherGenotype,
                          @RequestParam(name = "motherGenotype") String motherGenotype,
                          @RequestParam(name = "specialNeeds",required = false) String specialNeeds,
                          @RequestParam(name = "batchNum") String batchNum,
                          @RequestParam(name = "chiNum") String chiNum,
                          @RequestParam(name = "jiaoNum",required = false) String jiaoNum,
                          @RequestParam(name = "fatherChiNum",required = false) String fatherChiNum,
                          @RequestParam(name = "fatherJiaoNum",required = false) String fatherJiaoNum,
                          @RequestParam(name = "motherChiNum",required = false) String motherChiNum,
                          @RequestParam(name = "motherJiaoNum",required = false) String motherJiaoNum) throws Exception {
        httpServletRequest.setCharacterEncoding("UTF-8");
        Map<String, String> map = new HashMap<>();
        map.put("unitList", unitList);
        map.put("unitName", unitName);
        map.put("farmId", farmId);
        map.put("duckBreed", duckBreed);
        map.put("duckSex", duckSex);
        map.put("duckBirthPlace", duckBirthPlace);
        map.put("duckBirthDay", duckBirthDay);
        map.put("genotype", genotype);
        map.put("nowWeight", nowWeight);
        map.put("unitId", unitId);
        map.put("breedEnv", breedEnv);
//        map.put("hatchRate", hatchRate);
        map.put("fatherNum", fatherNum);
        map.put("motherNum", motherNum);
        map.put("fatherGenotype", fatherGenotype);
        map.put("motherGenotype", motherGenotype);
        map.put("specialNeeds", specialNeeds);
        map.put("batchNum", batchNum);
        map.put("chiNum", chiNum);
        map.put("jiaoNum", jiaoNum);
        map.put("fatherChiNum", fatherChiNum);
        map.put("fatherJiaoNum", fatherJiaoNum);
        map.put("motherChiNum", motherChiNum);
        map.put("motherJiaoNum", motherJiaoNum);
        return duckInfoService.addDuck(httpServletRequest, map, imgUrl);
    }

    @RequestMapping("/editDuck")
    public Result editDuck(HttpServletRequest httpServletRequest, @RequestBody BaseDuckInfo baseDuckInfo) {
        return duckInfoService.editDuck(httpServletRequest, baseDuckInfo);
    }

    @RequestMapping("/listDuckById")
    public Result listDuckById(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return duckInfoService.listDuckById(httpServletRequest, paramsMap);
    }

    @PostMapping("/getLocationById")
    public Result getLocationById(@RequestBody Map<String, String> paramsMap) {
        String duckNum = paramsMap.get("duckNum");
        BaseDuckInfo baseDuckInfo = duckInfoService.getOne(new QueryWrapper<BaseDuckInfo>().eq("duck_num", duckNum));
        if (ObjectUtil.isEmpty(baseDuckInfo)) {
            return new Result(10001, "鸭只不存在", false);
        }
        Map resultMap = new HashMap();
        resultMap.put("unitName", baseDuckInfo.getUnitName());
        resultMap.put("unitId", baseDuckInfo.getUnitId());
        return new Result(ResultCode.SUCCESS, resultMap);
    }

    @PostMapping("/getDuckNumByUnitId")
    public Result getDuckNumByUnitId(@RequestBody Map<String, String> paramsMap) {
        String unitId = paramsMap.get("unitId");
        String farmId = paramsMap.get("farmId");
        BaseDuckInfo baseDuckInfo = duckInfoService.getOne(new QueryWrapper<BaseDuckInfo>().eq("farm_id", farmId).eq("unit_id", unitId).eq("is_cage", 0));
        if (ObjectUtil.isEmpty(baseDuckInfo)) {
            return new Result(10001, "该笼位无鸭只", false);
        }
        Map resultMap = new HashMap();
        resultMap.put("chiNum", baseDuckInfo.getChiNum());
        resultMap.put("jiaoNum", baseDuckInfo.getJiaoNum());
        resultMap.put("batchNum", baseDuckInfo.getBatchNum());
        resultMap.put("unitName", baseDuckInfo.getUnitName());
        resultMap.put("duckNum", baseDuckInfo.getDuckNum());
        return new Result(ResultCode.SUCCESS, resultMap);
    }

    @PostMapping("/getDuckByJiaoNum")
    public Result getDuckByJiaoNum(@RequestBody Map<String, String> paramsMap) {
        String jiaoNum = paramsMap.get("jiaoNum");
        String farmId = paramsMap.get("farmId");
        BaseDuckInfo baseDuckInfo = duckInfoService.getOne(new QueryWrapper<BaseDuckInfo>().eq("farm_id", farmId).eq("jiao_num", jiaoNum).eq("is_cage", 0));
        if (ObjectUtil.isEmpty(baseDuckInfo)) {
            return new Result(10001, "鸭只不存在或鸭只已出笼", false);
        }
        Map resultMap = new HashMap();
        resultMap.put("chiNum", baseDuckInfo.getChiNum());
        resultMap.put("jiaoNum", baseDuckInfo.getJiaoNum());
        resultMap.put("batchNum", baseDuckInfo.getBatchNum());
        resultMap.put("unitId", baseDuckInfo.getUnitId());
        resultMap.put("unitName", baseDuckInfo.getUnitName());
        resultMap.put("duckNum", baseDuckInfo.getDuckNum());
        return new Result(ResultCode.SUCCESS, resultMap);
    }

    @PostMapping("/getDuckByChiNum")
    public Result getDuckByChiNum(@RequestBody Map<String, String> paramsMap) {
        String chiNum = paramsMap.get("chiNum");
        String farmId = paramsMap.get("farmId");
        BaseDuckInfo baseDuckInfo = duckInfoService.getOne(new QueryWrapper<BaseDuckInfo>().eq("farm_id", farmId).eq("chi_num", chiNum).eq("is_cage", 0));
        if (ObjectUtil.isEmpty(baseDuckInfo)) {
            return new Result(10001, "鸭只不存在或鸭只已出笼", false);
        }
        Map resultMap = new HashMap();
        resultMap.put("chiNum", baseDuckInfo.getChiNum());
        resultMap.put("jiaoNum", baseDuckInfo.getJiaoNum());
        resultMap.put("batchNum", baseDuckInfo.getBatchNum());
        resultMap.put("unitId", baseDuckInfo.getUnitId());
        resultMap.put("unitName", baseDuckInfo.getUnitName());
        resultMap.put("duckNum", baseDuckInfo.getDuckNum());
        return new Result(ResultCode.SUCCESS, resultMap);
    }

    @GetMapping("/printDuck")
    public void printDuck(HttpServletResponse response, @RequestParam(name = "duckCode") String duckCode,
                          @RequestParam(name = "startTime") String startTime,
                          @RequestParam(name = "endTime") String endTime
                          ) throws Exception {
        Map<String, String> map = new HashMap<>();
        map.put("duckCode", duckCode);
        map.put("startTime", startTime);
        map.put("endTime", endTime);
        duckInfoService.printDuck(response, map);
        String path = "/opt/guowei/duckTest.xls";
        PdfUtil.returnPdfStream3(response, path, "鸭只档案列表");
    }

    @GetMapping("/printChi")
    public void printChi(HttpServletResponse response, @RequestParam(name = "farmId") String farmId) throws Exception {
        Map<String, String> map = new HashMap<>();
        map.put("farmId", farmId);
        duckInfoService.printChi(response, map);
        String path = "/opt/guowei/chi.xls";
        PdfUtil.returnPdfStream3(response, path, "最新笼位列表");
    }

    //excel导入
    @PostMapping("/importData")
    public Result importData(HttpServletRequest httpServletRequest, @RequestParam(name = "file") MultipartFile file,
                             @RequestParam(name = "farmId") String farmId) throws Exception {
        Map<String, String> map = new HashMap<>();
        map.put("farmId", farmId);
        return duckInfoService.importData(httpServletRequest, map, file);
    }


    //大屏
    @RequestMapping("/listDuckByScreen")
    public Result listDuckByScreen(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return duckInfoService.listDuckByScreen(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listDuckByScreen2")
    public Result listDuckByScreen2(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) throws ParseException {
        return duckInfoService.listDuckByScreen2(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listDuckAll")
    public Result listDuckAll(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        QueryWrapper<BaseDuckInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", farmId);
        return new Result(ResultCode.SUCCESS, duckInfoService.list(queryWrapper));
    }
}
