package com.huimv.guowei.admin.controller;


import cn.hutool.core.util.ObjectUtil;
import com.alibaba.druid.util.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.BaseOverview;
import com.huimv.guowei.admin.service.IBaseOverviewService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-21
 */
@RestController
@RequestMapping("/base-overview")
@CrossOrigin
public class BaseOverviewController {
    @Resource
    private IBaseOverviewService baseOverviewService;

    @PostMapping("/getOverview")
    public Result getOverview(@RequestBody Map<String, String> paramsMap){
        String farmId = paramsMap.get("farmId");
        BaseOverview baseOverview = baseOverviewService.getOne(new QueryWrapper<BaseOverview>().eq("farm_id", farmId));
        if (ObjectUtil.isEmpty(baseOverview)){
            baseOverview = new BaseOverview();
            baseOverview.setFarmId(Integer.parseInt(farmId));
            baseOverview.setStock("0");
            baseOverview.setSale("0");
            baseOverview.setProduction("0");
        }
        if (StringUtils.isEmpty(baseOverview.getStock())){
            baseOverview.setStock("0");
        }
        if (StringUtils.isEmpty(baseOverview.getSale())){
            baseOverview.setSale("0");
        }
        if (StringUtils.isEmpty(baseOverview.getProduction())){
            baseOverview.setProduction("0");
        }
        baseOverviewService.saveOrUpdate(baseOverview);
        return new Result(ResultCode.SUCCESS,baseOverview);
    }

    @PostMapping("/saveOverview")
    public Result saveOverview(@RequestBody BaseOverview baseOverview){
        baseOverviewService.saveOrUpdate(baseOverview);
        return Result.SUCCESS();
    }
}
