package com.huimv.guowei.admin.controller;


import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.Batch;
import com.huimv.guowei.admin.service.impl.BatchServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 代次号 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-11-28
 */
@RestController
@RequestMapping("/batch")
@CrossOrigin
public class BatchController {

    @Autowired
    private BatchServiceImpl batchService;

    @RequestMapping("/listAll")
    public Result listAll(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        QueryWrapper<Batch> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", farmId).eq("is_enable",0);
        List<Batch> batches = batchService.list(queryWrapper);
        return new Result(ResultCode.SUCCESS, batches);
    }


    @RequestMapping("/listBatch")
    public Result listDuck(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return batchService.list(httpServletRequest, paramsMap);
    }

    @RequestMapping("/addBatch")
    public Result addBatch(HttpServletRequest httpServletRequest, @RequestBody Batch batch) {
        QueryWrapper<Batch> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", batch.getFarmId()).eq("batch_num", batch.getBatchNum());
        Batch one = batchService.getOne(queryWrapper);
        if (ObjectUtil.isNotEmpty(one)) {
            return new Result(10001, "添加失败，代次号已存在", false);
        } else {
            batchService.save(batch);
            return new Result(10000, "添加成功！", true);
        }

    }
    @RequestMapping("/deleteBatch")
    public Result deleteBatch(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        QueryWrapper<Batch> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("id", id);
        Batch batch = batchService.getOne(queryWrapper);
        if (batch.getIsEnable() == 0) {
            return new Result(10001, "删除失败，代次号正在被使用！", true);
        } else {
            batchService.removeById(id);
            return new Result(10000, "删除成功！", true);
        }

    }

    @RequestMapping("/editBatch")
    public Result editBatch(HttpServletRequest httpServletRequest,  @RequestBody Batch batch) {
        QueryWrapper<Batch> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", batch.getFarmId()).eq("batch_num", batch.getBatchNum())
                .ne("id", batch.getId());
        Batch one = batchService.getOne(queryWrapper);
        if (ObjectUtil.isNotEmpty(one)) {
            return new Result(10001, "修改失败，代次号已存在", false);
        } else {
            batchService.updateById(batch);
            return new Result(10000, "修改成功！", true);
        }

    }
}
