package com.huimv.guowei.admin.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.BaseDuckInfo;
import com.huimv.guowei.admin.entity.Departure;
import com.huimv.guowei.admin.entity.vo.DepartureVo;
import com.huimv.guowei.admin.service.IBaseDuckInfoService;
import com.huimv.guowei.admin.service.IDepartureService;
import com.huimv.guowei.admin.service.IDuckHealthInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-14
 */
@RestController
@RequestMapping("/departure")
@CrossOrigin
public class DepartureController {
    @Autowired
    private IDepartureService departureService;
    @Autowired
    private IBaseDuckInfoService infoService;

    @RequestMapping("/list")
    public Result listById(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return departureService.list(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listByDuckId")
    public Result listByDuckId(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        Departure departure = departureService.getById(id);
        if (1 == departure.getType()) {
            return new Result(ResultCode.SUCCESS, departure);
        } else {
            QueryWrapper<Departure> queryWrapper1 = new QueryWrapper<>();
            queryWrapper1.eq("batch_num", departure.getBatchNum()).eq("farm_id", departure.getFarmId());
            List<Departure> departures = departureService.list(queryWrapper1);
            DepartureVo departureVo = new DepartureVo();
            departureVo.setBatchNum(departure.getBatchNum());
            departureVo.setDate(departures.get(0).getDate());
            departureVo.setFarmId(departure.getFarmId());
            String s = "";
            for (int i = 0; i < departures.size(); i++) {
                if (i == departures.size() - 1) {
                    s = s + departures.get(i).getChiNum();
                } else {
                    s = s + departures.get(i).getChiNum() + ",";
                }
            }
            departureVo.setReason(departures.get(0).getReason());
            departureVo.setChiNum(s);
            departureVo.setType(2);
            return new Result(ResultCode.SUCCESS, departureVo);
        }
    }

    @RequestMapping("/listSelect")
    public Result listSelect(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return departureService.listSelect(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listByChiNum")
    public Result listByChiNum(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return departureService.listByChiNum(httpServletRequest, paramsMap);
    }

    @RequestMapping("/addDuck")
    public Result addDuck(HttpServletRequest httpServletRequest, @RequestBody Departure departure) {
        String duckNum = departure.getDuckNum();
        QueryWrapper<BaseDuckInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", departure.getFarmId()).eq("duck_num", duckNum);
        BaseDuckInfo infoServiceOne = infoService.getOne(queryWrapper);
        if (infoServiceOne.getIsCage() == 1) {
            return new Result(10001, "该鸭只已离场，无需再次离场！", false);
        }
        infoServiceOne.setIsCage(1);
        departure.setChiNum(infoServiceOne.getChiNum());
        departure.setJiaoNum(infoServiceOne.getJiaoNum());
        departure.setBatchNum(infoServiceOne.getBatchNum());
        departure.setType(1);
        departureService.save(departure);
        infoService.updateById(infoServiceOne);
        return new Result(10000, "添加成功！", true);
    }

    @RequestMapping("/editDuck")
    public Result editDuck(HttpServletRequest httpServletRequest, @RequestBody Departure departure) {
        departureService.updateById(departure);
        return new Result(10000, "修改成功！", true);
    }

    @RequestMapping("/deleteDuck")
    public Result deleteDuck(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        departureService.removeById(id);
        return new Result(10000, "删除成功！", true);
    }

    @RequestMapping("/editBatch")
    public Result editBatch(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) throws ParseException {
        return departureService.editBatch(httpServletRequest, paramsMap);
    }
}
