package com.huimv.guowei.admin.controller;


import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.DuckHealthInfo;
import com.huimv.guowei.admin.entity.vo.DuckHealthInfoVo;
import com.huimv.guowei.admin.service.IDuckHealthInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.text.ParseException;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/duck-health-info")
@CrossOrigin
public class DuckHealthInfoController {

    @Autowired
    private IDuckHealthInfoService healthInfoService;

    @RequestMapping("/listById")
    public Result listById(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return healthInfoService.listById(httpServletRequest, paramsMap);
    }

    @RequestMapping("/addDuck")
    public Result addDuck(HttpServletRequest httpServletRequest, @RequestBody DuckHealthInfo healthInfo) throws ParseException {
        return healthInfoService.addHealth(httpServletRequest, healthInfo);
    }

    @RequestMapping("/editDuck")
    public Result editDuck(HttpServletRequest httpServletRequest, @RequestBody DuckHealthInfo healthInfo) {
        healthInfoService.updateById(healthInfo);
        return new Result(10000,"修改成功！",true);
    }

    @RequestMapping("/deleteDuck")
    public Result deleteDuck(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        healthInfoService.removeById(id);
        return new Result(10000, "删除成功！", true);
    }

    @RequestMapping("/listH5")
    public Result listH5(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return healthInfoService.listByH5(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listSelect")
    public Result listSelect(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return healthInfoService.listSelect(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listByChiNum")
    public Result listByChiNum(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return healthInfoService.listByChiNum(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listByDuckId")
    public Result listByDuckId(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        return new Result(ResultCode.SUCCESS,healthInfoService.getById(id));
    }
}
