package com.huimv.guowei.admin.controller;


import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.DuckImmunityInfo;
import com.huimv.guowei.admin.service.IDuckImmunityInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.text.ParseException;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/duck-immunity-info")
@CrossOrigin
public class DuckImmunityInfoController {

    @Autowired
    private IDuckImmunityInfoService infoService;

    @RequestMapping("/listById")
    public Result listById(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return infoService.listById(httpServletRequest, paramsMap);
    }

    @RequestMapping("/addDuck")
    public Result addDuck(HttpServletRequest httpServletRequest, @RequestBody DuckImmunityInfo duckImmunityInfo) throws ParseException {
        return infoService.addImmunity(httpServletRequest, duckImmunityInfo);
    }

    @RequestMapping("/editDuck")
    public Result editDuck(HttpServletRequest httpServletRequest, @RequestBody DuckImmunityInfo immunityInfo) {
        infoService.updateById(immunityInfo);
        return new Result(10000, "修改成功！", true);
    }

    @RequestMapping("/deleteDuck")
    public Result deleteDuck(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        infoService.removeById(id);
        return new Result(10000,"删除成功！",true);
    }


    @RequestMapping("/listH5")
    public Result listH5(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return infoService.listByH5(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listSelect")
    public Result listSelect(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return infoService.listSelect(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listByChiNum")
    public Result listByChiNum(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return infoService.listByChiNum(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listByDuckId")
    public Result listByDuckId(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        return new Result(ResultCode.SUCCESS,infoService.getById(id));
    }

    //excel导入
    @PostMapping("/importData")
    public Result addDuck(HttpServletRequest httpServletRequest,@RequestParam(name = "file") MultipartFile files) throws Exception {
        return infoService.importData(httpServletRequest, files);
    }
}
