package com.huimv.guowei.admin.controller;


import com.huimv.guowei.admin.common.utils.PdfUtil;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.service.IEnergyElectricityService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/energy-electricity")
@CrossOrigin
public class EnergyElectricityController {
    @Resource
    private IEnergyElectricityService energyElectricityService;

    @PostMapping("/getElectricity")
    public Result getElectricity(@RequestBody Map<String ,String> paramsMap){
        return energyElectricityService.getElectricity(paramsMap);
    }

    @PostMapping("/listElectricity")
    public Result listElectricity(@RequestBody Map<String ,String> paramsMap){
        return energyElectricityService.listElectricity(paramsMap);
    }

    @PostMapping("/listUnitElectricity")
    public Result listUnitElectricity(@RequestBody Map<String ,String> paramsMap){
        return energyElectricityService.listUnitElectricity(paramsMap);
    }

    @PostMapping("/getScreenElectricity")
    public Result getScreenElectricity(@RequestBody Map<String ,String> paramsMap){
        return energyElectricityService.getScreenElectricity(paramsMap);
    }

    @PostMapping("/listScreenElectricity")
    public Result listScreenElectricity(@RequestBody Map<String ,String> paramsMap){
        return energyElectricityService.listScreenElectricity(paramsMap);
    }

    @GetMapping("/printElectricity")
    public void printDuck(HttpServletResponse response, @RequestParam(name = "type") String type,
                          @RequestParam(name = "farmId") String farmId,
                          @RequestParam(name = "startTime", required = false) String startTime,
                          @RequestParam(name = "endTime", required = false) String endTime) throws Exception {

        Map<String, String> map = new HashMap<>();
        map.put("type", type);
        map.put("farmId", farmId);
        if (startTime != null) {
            map.put("startTime", startTime);
            map.put("endTime", endTime);
        }
        energyElectricityService.printElectricity(response, map);
        String path = "/opt/guowei/electricity.xls";
        PdfUtil.returnPdfStream3(response, path, "用电信息");
    }
}
