package com.huimv.guowei.admin.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnergyWarningInfo;
import com.huimv.guowei.admin.service.IEnergyWarningInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Calendar;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/energy-warning-info")
@CrossOrigin
public class EnergyWarningInfoController {

    @Autowired
    private IEnergyWarningInfoService warningInfoService;

    @PostMapping("/listScreen")
    public Result listWaterLine(@RequestBody Map<String ,String> paramsMap){
        String farmId = paramsMap.get("farmId");
        String unitId = paramsMap.get("unitId");
        Calendar calendar = Calendar.getInstance();
        calendar.set(Calendar.DATE, calendar.get(Calendar.DATE) - 7);
        List<EnergyWarningInfo> list = warningInfoService.list(new QueryWrapper<EnergyWarningInfo>().eq("farm_id", farmId)
                .eq("unit_id", unitId).ge("date", calendar.getTime()));
        return new Result(ResultCode.SUCCESS, list);
    }
}
