package com.huimv.guowei.admin.controller;


import com.huimv.guowei.admin.common.utils.PdfUtil;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.service.IEnergyWaterService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/energy-water")
@CrossOrigin
public class EnergyWaterController {
    @Resource
    private IEnergyWaterService energyWaterService;

    @PostMapping("/getWater")
    public Result getWater(@RequestBody Map<String ,String> paramsMap){
        return energyWaterService.getWater(paramsMap);
    }

    @PostMapping("/listWater")
    public Result listWater(@RequestBody Map<String ,String> paramsMap){
        return energyWaterService.listWater(paramsMap);
    }

    @PostMapping("/listWaterLine")
    public Result listWaterLine(@RequestBody Map<String ,String> paramsMap){
        return energyWaterService.listWaterLine(paramsMap);
    }

    @PostMapping("/getScreenWaterLine")
    public Result getScreenWaterLine(@RequestBody Map<String ,String> paramsMap){
        return energyWaterService.getScreenWaterLine(paramsMap);
    }

    @PostMapping("/listScreenWaterLine")
    public Result listScreenWaterLine(@RequestBody Map<String ,String> paramsMap){
        return energyWaterService.listScreenWaterLine(paramsMap);
    }

    @PostMapping("/listScreenUnitWater")
    public Result listScreenUnitWater(@RequestBody Map<String ,String> paramsMap){
        return energyWaterService.listScreenUnitWater(paramsMap);
    }

    @GetMapping("/printWater")
    public void printDuck(HttpServletResponse response, @RequestParam(name = "type") String type,
                          @RequestParam(name = "farmId") String farmId,
                          @RequestParam(name = "startTime", required = false) String startTime,
                          @RequestParam(name = "endTime", required = false) String endTime) throws Exception {

        Map<String, String> map = new HashMap<>();
        map.put("type", type);
        map.put("farmId", farmId);
        if (startTime != null) {
            map.put("startTime", startTime);
            map.put("endTime", endTime);
        }
        energyWaterService.printWater(response, map);
        String path = "/opt/guowei/water.xls";
        PdfUtil.returnPdfStream3(response, path, "用水信息");
    }

    //平养用水
    @PostMapping("/listWaterGroup")
    public Result listWaterGroup(@RequestBody Map<String ,String> paramsMap){
        return energyWaterService.listWaterGroup(paramsMap);
    }

    //大屏平养区用水监测
    @PostMapping("/screenWater")
    public Result screenWater(@RequestBody Map<String ,String> paramsMap){
        return energyWaterService.screenWater(paramsMap);
    }
}
