package com.huimv.guowei.admin.controller;


import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnvDeviceOnline;
import com.huimv.guowei.admin.service.IEnvDeviceOnlineService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/env-device-online")
@CrossOrigin
public class EnvDeviceOnlineController {
    @Resource
    private IEnvDeviceOnlineService envDeviceOnlineService;
    @PostMapping("/getDeviceStatus")
    public Result getDate(@RequestBody Map<String ,String> paramsMap){
        String farmId = paramsMap.get("farmId");
        Map resultMap = new HashMap();
        EnvDeviceOnline envDeviceOnline = envDeviceOnlineService.getOne(new QueryWrapper<EnvDeviceOnline>().eq("farm_id", farmId).orderByDesc("creat_time").last("limit 1"));
        if (ObjectUtil.isEmpty(envDeviceOnline)){
            resultMap.put("totalDevice",0);
            resultMap.put("deviceOn",0);
            resultMap.put("deviceOff",0);
            resultMap.put("onlineRate",0.0);
        }else {
            resultMap.put("totalDevice",envDeviceOnline.getDeviceOn()+envDeviceOnline.getDeviceOff());
            resultMap.put("deviceOn",envDeviceOnline.getDeviceOn());
            resultMap.put("deviceOff",envDeviceOnline.getDeviceOff());
            resultMap.put("onlineRate",envDeviceOnline.getOnlineRate());
        }
        return new Result(ResultCode.SUCCESS,resultMap);

    }

}
