package com.huimv.guowei.admin.controller;


import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.BaseDuckInfo;
import com.huimv.guowei.admin.entity.DuckImmunityInfo;
import com.huimv.guowei.admin.entity.EnvMoveCall;
import com.huimv.guowei.admin.service.IBaseDuckInfoService;
import com.huimv.guowei.admin.service.IEnvMoveCallService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/env-move-call")
@CrossOrigin
public class EnvMoveCallController {

    @Autowired
    private IEnvMoveCallService moveCallService;
    @Autowired
    private IBaseDuckInfoService duckInfoService;

    @RequestMapping("/listById")
    public Result listById(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return moveCallService.listById(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listWeight")
    public Result listWeight(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return moveCallService.listWeight(httpServletRequest, paramsMap);
    }

    @RequestMapping("/addDuck")
    public Result addDuck(HttpServletRequest httpServletRequest, @RequestBody EnvMoveCall envMoveCall) throws ParseException {
        if (envMoveCall.getDuckWeight().compareTo(BigDecimal.ZERO) !=1) {
            return new Result(10001, "体重必须大于0", false);
        } else {
            QueryWrapper<BaseDuckInfo> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("farm_id", envMoveCall.getFarmId()).eq("duck_num", envMoveCall.getDuckNum());
            BaseDuckInfo duckInfo = duckInfoService.getOne(queryWrapper);
            BaseDuckInfo baseDuckInfo = duckInfoService.getOne(new QueryWrapper<BaseDuckInfo>().eq("farm_id", envMoveCall.getFarmId()).eq("duck_num", envMoveCall.getDuckNum()).eq("is_cage", 0));
            if (ObjectUtil.isEmpty(baseDuckInfo)) {
                return new Result(10001, "鸭只不存在或鸭只已出笼", false);
            }
            Date callDate = envMoveCall.getCallDate();
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            String month = sdf.format(callDate);
            Date date = new Date();
            SimpleDateFormat sdf1 = new SimpleDateFormat("HH:mm:ss");
            String time = sdf1.format(date);
            String endDate = month + " " + time;
            SimpleDateFormat sdf2 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

            envMoveCall.setCallDate(sdf2.parse(endDate));
            envMoveCall.setDayage(duckInfo.getDayAge());
            envMoveCall.setDuckId(duckInfo.getId());
            envMoveCall.setChiNum(duckInfo.getChiNum());
            envMoveCall.setJiaoNum(duckInfo.getJiaoNum());
            envMoveCall.setBatchNum(duckInfo.getBatchNum());
            moveCallService.save(envMoveCall);
            return new Result(10000, "添加成功！", true);
        }
    }

    @RequestMapping("/editDuck")
    public Result editDuck(HttpServletRequest httpServletRequest, @RequestBody EnvMoveCall envMoveCall) {
        moveCallService.updateById(envMoveCall);
        return new Result(10000, "修改成功！", true);
    }

    @RequestMapping("/deleteDuck")
    public Result deleteDuck(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        moveCallService.removeById(id);
        return new Result(10000,"删除成功！",true);
    }

    @RequestMapping("/listH5")
    public Result listH5(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return moveCallService.listByH5(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listSelect")
    public Result listSelect(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return moveCallService.listSelect(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listByDuckId")
    public Result listByDuckId(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        return new Result(ResultCode.SUCCESS,moveCallService.getById(id));
    }

    public static void main(String[] args) {
        Date date = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");
        System.out.println(sdf.format(date));

    }
}
