package com.huimv.guowei.admin.controller;


import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.service.IEnvRegularCallFeedingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 * 固定电子秤 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/env-regular-call-feeding")
@CrossOrigin
public class EnvRegularCallFeedingController {

    @Autowired
    private IEnvRegularCallFeedingService feedingService;

    @RequestMapping("/listById")
    public Result listById(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return feedingService.listById(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listByH5")
    public Result listByH5(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return feedingService.listByH5(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listSelect")
    public Result listSelect(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return feedingService.listSelect(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listByChiNum")
    public Result listByChiNum(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return feedingService.listByChiNum(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listSeven")
    public Result listSeven(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return feedingService.listSeven(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listAll")
    public Result listAll(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return feedingService.listAll(httpServletRequest, paramsMap);
    }

    @PostMapping("/getScreenFeed")
    public Result getScreenFeed(@RequestBody Map<String, String> paramsMap){
        return feedingService.getScreenFeed(paramsMap);
    }

    @PostMapping("/listScreenFeed")
    public Result listScreenFeed(@RequestBody Map<String, String> paramsMap){
        return feedingService.listScreenFeed(paramsMap);
    }

}
