package com.huimv.guowei.admin.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnvWarningInfo;
import com.huimv.guowei.admin.service.IEnvWarningInfoService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/env-warning-info")
@CrossOrigin
public class EnvWarningInfoController {
    @Resource
    private IEnvWarningInfoService envWarningInfoService;

    @PostMapping("/listWarning")
    public Result listWarning(@RequestBody Map<String ,String> paramsMap){
        return envWarningInfoService.listWarning(paramsMap);
    }
    @PostMapping("/listScreenWarning")
    public Result listScreenWarning(@RequestBody Map<String ,String> paramsMap){
        String farmId = paramsMap.get("farmId");
        LocalDateTime startOfDay = LocalDateTime.of(LocalDate.now(), LocalTime.MIN);
        LocalDateTime endOfDay = LocalDateTime.of(LocalDate.now(), LocalTime.MAX);
        List<EnvWarningInfo> envWarningInfos = envWarningInfoService.list(new QueryWrapper<EnvWarningInfo>().eq("farm_id", farmId).between("date",startOfDay,endOfDay).orderByDesc("date"));
        return new Result(ResultCode.SUCCESS,envWarningInfos);
    }

}
