package com.huimv.guowei.admin.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.SysCamera;
import com.huimv.guowei.admin.entity.SysCameraBrand;
import com.huimv.guowei.admin.service.ISysCameraBrandService;
import com.huimv.guowei.admin.service.ISysCameraService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/cameraBrand")
@CrossOrigin
public class SysCameraBrandController {
    @Autowired
    private ISysCameraBrandService cameraBrandService;
    @Autowired
    private ISysCameraService cameraService;

    @PostMapping("/list")
    public Result list(@RequestBody Map<String, Object> params) {
        return cameraBrandService.listPage(params);
    }

    @PostMapping("/add")
    public Result add(@RequestBody SysCameraBrand cameraBrand) {
        int brandName = cameraBrandService.count(new QueryWrapper<SysCameraBrand>().eq("brand_name", cameraBrand.getBrandName()).eq("farm_id", cameraBrand.getFarmId()));
        if (brandName > 0) {
            return new Result(10001, "品牌名称重复", false);
        }

        cameraBrandService.save(cameraBrand);
        return new Result(10000, "添加成功", true);
    }

    @PostMapping("/update")
    public Result update(@RequestBody SysCameraBrand cameraArea) {
        cameraBrandService.updateById(cameraArea);
        int brandName = cameraBrandService.count(new QueryWrapper<SysCameraBrand>().eq("brand_name", cameraArea.getBrandName()).eq("farm_id", cameraArea.getFarmId()));
        if (brandName > 1) {
            return new Result(10001, "品牌名称重复", false);
        }
        String areaName = cameraArea.getBrandName();
        SysCamera camera = new SysCamera();
        if (StringUtils.isNotBlank(areaName)) {
            camera.setBrandName(areaName);
        }
        UpdateWrapper<SysCamera> wrapper = new UpdateWrapper<>();
        wrapper.eq("brand_id", cameraArea.getId());
        cameraService.update(camera, wrapper);

        return new Result(ResultCode.SUCCESS, "修改成功");
    }

    @GetMapping("/remove")
    public Result remove(@RequestParam(value = "ids") List<Integer> ids,@RequestParam(value = "farmId") String farmId) {
        return cameraBrandService.removeIds(ids,farmId);
    }

}
