package com.huimv.guowei.admin.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 孵化登记
 * </p>
 *
 * @author author
 * @since 2023-06-14
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("duck_incubate_info")
public class DuckIncubateInfo implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    private String duckNum;

    private Integer duckId;

    /**
     * 位置（预留字段）
     */
    private String location;

    /**
     * 单元名字（位置）
     */
    private String unitName;

    private Integer unitId;

    /**
     * 产蛋日期
     */
//    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    private String layEggsTime;

    /**
     * 产蛋数量(枚)
     */
    private Integer layEggsNum;

    /**
     * 孵化日期
     */
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    private Date incubateTime;

    /**
     * 孵化数量(枚)
     */
    private Integer incubateNum;

    /**
     * 孵化率
     */
    private String incubateRate;

    /**
     * 健雏数
     */
    private Integer healthyDuckNum;

    /**
     * 健雏率
     */
    private String healthyDuckRate;

    /**
     * 受精蛋数
     */
    private Integer fertilizedNum;

    /**
     * 受精率
     */
    private String fertilizedRate;

    private Integer farmId;

    private String chiNum;

    private String jiaoNum;

    private String batchNum;


}
