package com.huimv.guowei.admin.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import java.util.Date;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 环控绑定设备
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("env_device_equipment")
public class EnvDeviceEquipment implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    private String equipmentName;

    private Integer unitId;

    /**
     * 0关闭 1开启 实际运行状态
     */
    private Integer openStart;

    /**
     * 端口号
     */
    private Integer equipmentPort;

    private String deviceCode;

    /**
     * 0关闭 1开启 设置状态
     */
    private Integer uploadStart;

    /**
     * 是否绑定 1绑定 0未绑定
     */
    private Integer binding;

    /**
     * 设备别名
     */
    private String deviceAlias;

    /**
     * 设备code
     */
    private String chipId;

    private Integer equipmentType;

    /*响应时间*/
    private Date updateTime;

    private Integer farmId;

}
