package com.huimv.guowei.admin.entity.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 * 固定电子秤
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("env_regular_call_feeding")
public class EnvRegularCallFeedingVo implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 设备名称
     */
    private String callName;

    /**
     * 设备编码
     */
    private String callCode;

    /**
     * 鸭只编号
     */
    private String duckNum;

    /**
     * 采食重量 克
     */
    private Integer duckWeight;

    /**
     * 原始数据
     */
    private Integer duckFeedingOriginal;

    /**
     * 称重日期
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date callDate;

    private Integer farmId;

    private Integer duckId;

    private BigDecimal avgWeight;


}
