package com.huimv.guowei.admin.group.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.group.entity.GroupBatch;
import com.huimv.guowei.admin.group.service.IGroupBatchService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

/**
 * <p>
 * 平养批次 前端控制器
 * </p>
 *
 * @author author
 * @since 2024-09-25
 */
@RestController
@RequestMapping("/group-batch")
@CrossOrigin
public class GroupBatchController {

    @Autowired
    private IGroupBatchService batchService;

    @RequestMapping("/listPage")
    public Result listPage(@RequestBody Map<String, String> paramsMap) {
        return batchService.listPage(paramsMap);
    }

    @RequestMapping("/add")
    public Result add(@RequestBody GroupBatch groupBatch) {
        return batchService.add(groupBatch);
    }

    @RequestMapping("/edit")
    public Result edit(@RequestBody GroupBatch groupBatch) {
        return batchService.edit(groupBatch);
    }

    @RequestMapping("/remove")
    public Result remove(@RequestBody Map<String, String> paramsMap) {
        return batchService.remove(paramsMap);
    }

    @RequestMapping("/list")
    public Result list(@RequestBody Map<String, String> paramsMap) {
        return new Result(ResultCode.SUCCESS,batchService.list(new QueryWrapper<GroupBatch>().eq("farm_id",paramsMap.get("farmId"))));
    }

    //大屏平养区健康评估
    @RequestMapping("/screenBatch")
    public Result screenBatch(@RequestBody Map<String, String> paramsMap) {
        return batchService.screenBatch(paramsMap);
    }
}
