package com.huimv.guowei.admin.group.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 建议信息
 * </p>
 *
 * @author author
 * @since 2024-10-08
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("group_advise")
public class GroupAdvise implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 提醒时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;


    /**
     * 脚环号
     */
    private String deviceCode;

    /**
     * 批次号
     */
    private String batchNum;

    /**
     * 栋舍id
     */
    private Integer unitId;

    /**
     * 栋舍名称
     */
    private String unitName;

    /**
     * 提示原因
     */
    private String version;

    /**
     * 建议类型 0未体检建议 1为淘汰建议
     */
    private Integer type;

    /**
     * 牧场编码
     */
    private Integer farmId;


}
