package com.huimv.guowei.admin.group.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 平养采食记录
 * </p>
 *
 * @author author
 * @since 2024-09-25
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("group_eating")
public class GroupEating implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 脚环号
     */
    private String deviceCode;

    /**
     * 采食量
     */
    private String eatingValue;

    /**
     * 采食日期
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date eatingDate;

    /**
     * 批次号
     */
    private String batchNum;

    /**
     * 牧场编码
     */
    private Integer farmId;

    /**
     * 栋舍id
     */
    private Integer unitId;

    /**
     * 栋舍名称
     */
    private String unitName;

    /**
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date createTime;


}
