package com.huimv.guowei.admin.group.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 平养投料捡蛋
 * </p>
 *
 * @author author
 * @since 2024-09-25
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("group_feeding_egg")
public class GroupFeedingEgg implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 栋舍id
     */
    private Integer unitId;

    /**
     * 栋舍名称
     */
    private String unitName;

    /**
     * 投料或产蛋时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date dateTime;

    /**
     * 饲料重量
     */
    private String feedValue;

    /**
     * 产蛋数量
     */
    private Integer eggNum;

    /**
     * 0为投料 1为产蛋
     */
    private Integer type;

    /**
     * 饲料种类
     */
    private String feedType;

    /**
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date createTime;

    /**
     * 牧场编码
     */
    private Integer farmId;

    private String eggWeight;

    private String eggAvg;


}
