package com.huimv.guowei.admin.group.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 参数设置
 * </p>
 *
 * @author author
 * @since 2024-10-08
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("group_threshold")
public class GroupThreshold implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 平均采食时间
     */
    private String avgFeeding;

    /**
     * 平均产蛋时间
     */
    private String avgEgg;

    /**
     * 采食采集时间下限
     */
    private String feedTimeDown;

    /**
     * 采食采集时间上线
     */

    private String feedTimeUpper;

    /**
     * 产蛋采集时间下限
     */

    private String eggTimeDown;

    /**
     * 产蛋采集时间上线
     */

    private String eggTimeUpper;

    /**
     * 最长时间未读取
     */
    private String times;

    /**
     * 料蛋比
     */
    private String feedEggRank;

    /**
     * 日产蛋量低阈值
     */
    private String dayFeedDown;

    /**
     * 日采食量高阈值
     */
    private String dayFeedUpper;

    /**
     * 日产蛋量低阈值
     */
    private String dayEggDown;

    /**
     * 日产蛋量高阈值
     */
    private String dayEggUpper;

    /**
     * 牧场编码
     */
    private Integer farmId;

    private String first;

    private String second;


}
