package com.huimv.guowei.admin.group.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.group.entity.GroupAdvise;
import com.huimv.guowei.admin.group.mapper.GroupAdviseMapper;
import com.huimv.guowei.admin.group.service.IGroupAdviseService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * <p>
 * 建议信息 服务实现类
 * </p>
 *
 * @author author
 * @since 2024-10-08
 */
@Service
public class GroupAdviseServiceImpl extends ServiceImpl<GroupAdviseMapper, GroupAdvise> implements IGroupAdviseService {

    @Autowired
    private GroupAdviseMapper adviseMapper;

    @Override
    public Result listPage(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String pageNum = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        if ("".equals(pageNum) || null == pageNum) {
            pageNum = "1";
            pageSize = "20";
        }
        String type = paramsMap.get("type");
        Page<GroupAdvise> page = new Page(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
        QueryWrapper<GroupAdvise> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", farmId).eq(StringUtils.isNotBlank(type),"type", type).orderByDesc("create_time");
        return new Result(ResultCode.SUCCESS, adviseMapper.selectPage(page, queryWrapper));
    }
}
