package com.huimv.guowei.admin.group.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.group.entity.GroupThreshold;
import com.huimv.guowei.admin.group.mapper.GroupThresholdMapper;
import com.huimv.guowei.admin.group.service.IGroupThresholdService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * <p>
 * 参数设置 服务实现类
 * </p>
 *
 * @author author
 * @since 2024-10-08
 */
@Service
public class GroupThresholdServiceImpl extends ServiceImpl<GroupThresholdMapper, GroupThreshold> implements IGroupThresholdService {

    @Autowired
    private GroupThresholdMapper thresholdMapper;

    @Override
    public Result list(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        QueryWrapper<GroupThreshold> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", farmId);
        return new Result(ResultCode.SUCCESS, thresholdMapper.selectOne(queryWrapper));
    }

    @Override
    public Result addAndEdit(GroupThreshold groupThreshold) {
        QueryWrapper<GroupThreshold> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", groupThreshold.getFarmId());
        if (ObjectUtil.isNotEmpty(thresholdMapper.selectOne(queryWrapper))) {
            thresholdMapper.updateById(groupThreshold);
        } else {
            thresholdMapper.insert(groupThreshold);
        }
        return new Result(ResultCode.SUCCESS);
    }
}
