package com.huimv.guowei.admin.mapper;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.huimv.guowei.admin.entity.EnergyElectricity;
import com.huimv.guowei.admin.entity.EnergyWater;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.huimv.guowei.admin.entity.dto.ScreenWaterVo;
import com.huimv.guowei.admin.entity.vo.EnergyWaterVo;
import com.huimv.guowei.admin.entity.vo.WaterLineVo;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;
import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
public interface EnergyWaterMapper extends BaseMapper<EnergyWater> {

    List<EnergyWater> listDayDetail(String farmId);

    List<EnergyWater> listWeekDetail(String farmId);

    List<EnergyWater> listMonthDetail(String farmId);

    List<EnergyWater> listCustomDetail(@Param("farmId") String farmId,@Param("startDate") String startDate,@Param("endDate") String endDate);

    BigDecimal getDayWater(String farmId);

    BigDecimal getMonthWater(String farmId);

    BigDecimal getWater(@Param(Constants.WRAPPER) QueryWrapper<EnergyWater> queryWrapper);

    List<WaterLineVo> listWaterLineDayDetail(String farmId, List<String> chipCodeList, String chipCodes);

    List<WaterLineVo> listWaterLineWeekDetail(String farmId, List<String> chipCodeList, String chipCodes);

    List<WaterLineVo> listWaterLineMonthDetail(String farmId, List<String> chipCodeList, String chipCodes);

    List<WaterLineVo> listWaterLineCustomDetail(String farmId, List<String> chipCodeList, String chipCodes ,String startDate, String endDate);

    List<WaterLineVo> listSixMonthWaterLine(String farmId, List<String> chipCodeList, String chipCodes);

    List<WaterLineVo> listSevenDayWaterLine(String farmId, List<String> chipCodeList, String chipCodes);

    BigDecimal getLastFlowByUnitId(String farmId, String unitId);

    BigDecimal getUnitDayWater(String farmId, String unitId);

    List<EnergyWater> listUnitDayDetail(String farmId, String unitId);

    List<EnergyWater> listUnitMonthDetail(String farmId, String unitId);

    List<EnergyWater> printWater(@Param(Constants.WRAPPER) QueryWrapper<EnergyWater> queryWrapper);

    EnergyWater printWaterCount(@Param(Constants.WRAPPER) QueryWrapper<EnergyWater> queryWrapper);

    List<EnergyWater> listDayGroupDetail(@Param(Constants.WRAPPER) QueryWrapper<EnergyWater> queryWrapper);

    List<EnergyWater> listDayGroupDetail2(@Param(Constants.WRAPPER) QueryWrapper<EnergyWater> queryWrapper);

    List<ScreenWaterVo> screenWater(@Param(Constants.WRAPPER) QueryWrapper<EnergyWater> queryWrapper);
}
