package com.huimv.guowei.admin.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.BaseDuckInfo;
import com.huimv.guowei.admin.entity.Batch;
import com.huimv.guowei.admin.entity.vo.BatchVo;
import com.huimv.guowei.admin.mapper.BaseDuckInfoMapper;
import com.huimv.guowei.admin.mapper.BatchMapper;
import com.huimv.guowei.admin.service.IBatchService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 代次号 服务实现类
 * </p>
 *
 * @author author
 * @since 2023-11-28
 */
@Service
public class BatchServiceImpl extends ServiceImpl<BatchMapper, Batch> implements IBatchService {

    @Autowired
    private BatchMapper batchMapper;
    @Autowired
    private BaseDuckInfoMapper infoMapper;
    @Override
    public Result list(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String batchNum = paramsMap.get("batchNum");
        String pageNum = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        if (pageNum == null || "".equals(pageNum)) {
            pageNum = "1";
        }
        if (pageSize == null || "".equals(pageSize)) {
            pageSize = "10";
        }
        QueryWrapper<Batch> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", farmId).like(StringUtils.isNotBlank(batchNum), "batch_num", batchNum);
        Page<Batch> page = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
        Page<Batch> batchPage = batchMapper.selectPage(page, queryWrapper);
        List<Batch> records = batchPage.getRecords();
        for (Batch record : records) {
            QueryWrapper<BaseDuckInfo> queryWrapper1 = new QueryWrapper<>();
            queryWrapper1.eq("farm_id", farmId).eq("batch_num", record.getBatchNum());
            Integer count = infoMapper.selectCount(queryWrapper1);
            record.setCount(count);
        }
        return new Result(ResultCode.SUCCESS, batchPage);
    }
}
