package com.huimv.guowei.admin.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.DeviceFarmConfig;
import com.huimv.guowei.admin.mapper.DeviceFarmConfigMapper;
import com.huimv.guowei.admin.service.IDeviceFarmConfigService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2023-09-12
 */
@Service
public class DeviceFarmConfigServiceImpl extends ServiceImpl<DeviceFarmConfigMapper, DeviceFarmConfig> implements IDeviceFarmConfigService {

    @Override
    public Result list(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        List<DeviceFarmConfig> farm_id = this.list(new QueryWrapper<DeviceFarmConfig>().eq("farm_id", farmId));

        if (ObjectUtil.isEmpty(farm_id)){
            List list  =new ArrayList();
            DeviceFarmConfig deviceFarmConfig = new DeviceFarmConfig();
            deviceFarmConfig.setStartHour(6);
            deviceFarmConfig.setEndHour(8);
            deviceFarmConfig.setFarmId(Integer.parseInt(farmId));
            this.save(deviceFarmConfig);
            list.add(deviceFarmConfig);
            deviceFarmConfig.setStartHour(15);
            deviceFarmConfig.setEndHour(18);
            this.save(deviceFarmConfig);
            list.add(deviceFarmConfig);
            return new Result(ResultCode.SUCCESS,list);
        }
        return new Result(ResultCode.SUCCESS,farm_id);
    }

    @Override
    public Object updateByFarmId(Map<String, String> paramsMap) {
        return null;
    }
}
