package com.huimv.guowei.admin.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.DuckBodySizeInfo;
import com.huimv.guowei.admin.entity.DuckEggTextureInfo;
import com.huimv.guowei.admin.entity.DuckIncubateInfo;
import com.huimv.guowei.admin.mapper.DuckIncubateInfoMapper;
import com.huimv.guowei.admin.service.IDuckIncubateInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 孵化登记 服务实现类
 * </p>
 *
 * @author author
 * @since 2023-06-14
 */
@Service
public class DuckIncubateInfoServiceImpl extends ServiceImpl<DuckIncubateInfoMapper, DuckIncubateInfo> implements IDuckIncubateInfoService {
    @Resource
    private DuckIncubateInfoMapper duckIncubateInfoMapper;

    @Override
    public Result listLimitInfo(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String num = paramsMap.get("num");
        List<DuckIncubateInfo> duckIncubateInfoList = duckIncubateInfoMapper.selectList(new QueryWrapper<DuckIncubateInfo>()
                .eq("farm_id",farmId).orderByDesc("id").last("limit "+num));
        return new Result(ResultCode.SUCCESS,duckIncubateInfoList);
    }

    @Override
    public Result listPageInfo(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String pageNo = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        String unitName = paramsMap.get("unitName");
        Page<DuckIncubateInfo> page = new Page(Integer.parseInt(pageNo),Integer.parseInt(pageSize));
        Page<DuckIncubateInfo> duckIncubateInfoPage = duckIncubateInfoMapper.selectPage(page,
                new QueryWrapper<DuckIncubateInfo>().eq("farm_id",farmId)
                        .like("unit_name", unitName)
                        .or(wrapper -> wrapper.like("chi_num", unitName).or().like("jiao_num", unitName)).orderByDesc("id"));
        return new Result(ResultCode.SUCCESS,duckIncubateInfoPage);
    }

    @Override
    public Result listWeekInfo(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String unitName = paramsMap.get("unitName");
        List<DuckIncubateInfo> duckIncubateInfoList = duckIncubateInfoMapper.listWeekInfo(farmId,unitName);
        return new Result(ResultCode.SUCCESS,duckIncubateInfoList);
    }
}
