package com.huimv.guowei.admin.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnergyWarningThreshold;
import com.huimv.guowei.admin.mapper.EnergyWarningThresholdMapper;
import com.huimv.guowei.admin.service.IEnergyWarningThresholdService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@Service
public class EnergyWarningThresholdServiceImpl extends ServiceImpl<EnergyWarningThresholdMapper, EnergyWarningThreshold> implements IEnergyWarningThresholdService {

    @Autowired
    private EnergyWarningThresholdMapper thresholdMapper;

    @Override
    public Result saveThreshold(EnergyWarningThreshold warningThreshold) {
        Integer farmId = warningThreshold.getFarmId();
        EnergyWarningThreshold threshold = thresholdMapper.selectOne(new QueryWrapper<EnergyWarningThreshold>().eq("farm_id", farmId));
        if (ObjectUtil.isNotEmpty(threshold)) {
            thresholdMapper.updateById(warningThreshold);
        } else {
            thresholdMapper.insert(warningThreshold);
        }
        return new Result(ResultCode.SUCCESS);
    }

    @Override
    public Result getThreshold(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        EnergyWarningThreshold threshold = thresholdMapper.selectOne(new QueryWrapper<EnergyWarningThreshold>().eq("farm_id", farmId));
        if (ObjectUtil.isNotEmpty(threshold)) {
            return new Result(ResultCode.SUCCESS, threshold);
        } else {
            EnergyWarningThreshold threshold1 = new EnergyWarningThreshold();
            threshold1.setElectricityCount("0");
            threshold1.setGroupPressure("0");
            threshold1.setGroupWater("0");
            threshold1.setPressureFour("0");
            threshold1.setPressureOne("0");
            threshold1.setPressureThree("0");
            threshold1.setPressureTwo("0");
            threshold1.setWaterCount("0");
            threshold1.setWaterFour("0");
            threshold1.setWaterOne("0");
            threshold1.setWaterThree("0");
            threshold1.setWaterTwo("0");
            return new Result(ResultCode.SUCCESS, threshold1);
        }

    }

}
