package com.huimv.guowei.admin.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnvDeviceEquipment;
import com.huimv.guowei.admin.mapper.EnvDeviceEquipmentMapper;
import com.huimv.guowei.admin.service.IEnvDeviceEquipmentService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 * 环控绑定设备 服务实现类
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@Service
public class EnvDeviceEquipmentServiceImpl extends ServiceImpl<EnvDeviceEquipmentMapper, EnvDeviceEquipment> implements IEnvDeviceEquipmentService {

    @Autowired
    private EnvDeviceEquipmentMapper equipmentMapper ;
    @Override
    public Result listScreen(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String unitId = paramsMap.get("unitId");
        String type = paramsMap.get("type");//显示设备类型
        if ("".equals(type) || null == type) {
            type = "1";
        }
        String pageNum = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        if ("".equals(pageNum) || null == pageNum) {
            pageNum = "1";
        }
        if ("".equals(pageSize) || null == pageSize) {
            pageSize = "4";
        }
        Page<EnvDeviceEquipment> page = new Page(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
        QueryWrapper<EnvDeviceEquipment> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", farmId).eq("unit_id", unitId).eq("equipment_type", type)
                .orderByAsc("equipment_port");
        return new Result(ResultCode.SUCCESS, equipmentMapper.selectPage(page, queryWrapper));
    }
}
