package com.huimv.guowei.admin.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnvWarningInfo;
import com.huimv.guowei.admin.mapper.EnvWarningInfoMapper;
import com.huimv.guowei.admin.service.IEnvWarningInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@Service
public class EnvWarningInfoServiceImpl extends ServiceImpl<EnvWarningInfoMapper, EnvWarningInfo> implements IEnvWarningInfoService {


    @Override
    public Result listWarning(Map<String, String> paramsMap) {
        String type = paramsMap.get("type");
        String farmId = paramsMap.get("farmId");
        String pageNo = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        Page<EnvWarningInfo> page = new Page(Integer.parseInt(pageNo),Integer.valueOf(pageSize));
        //温湿度
        if ("0".equals(type)){
            page = this.page(page, new QueryWrapper<EnvWarningInfo>().in("warning_type", 1, 2).eq("farm_id",farmId).orderByDesc("date"));
        }
        //水
        else if ("1".equals(type)){
            page = this.page(page, new QueryWrapper<EnvWarningInfo>().eq("warning_type", 3).eq("farm_id",farmId).orderByDesc("date"));
        }
        //电
        else if ("2".equals(type)){
            page = this.page(page, new QueryWrapper<EnvWarningInfo>().eq("warning_type", 4).eq("farm_id",farmId).orderByDesc("date"));
        }
        return new Result(ResultCode.SUCCESS,page);
    }
}
