package com.huimv.guowei.admin.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.SysCamera;
import com.huimv.guowei.admin.entity.SysCameraBrand;
import com.huimv.guowei.admin.mapper.SysCameraBrandMapper;
import com.huimv.guowei.admin.mapper.SysCameraMapper;
import com.huimv.guowei.admin.service.ISysCameraBrandService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@Service
public class SysCameraBrandServiceImpl extends ServiceImpl<SysCameraBrandMapper, SysCameraBrand> implements ISysCameraBrandService {
    @Autowired
    private SysCameraMapper cameraMapper;

    @Override
    public Result listPage(Map<String, Object> params) {
        Integer current = (Integer) params.get("current");
        Integer size = (Integer) params.get("size");
        String brandName = (String) params.get("brandName");
        Integer farmId = Integer.parseInt(params.get("farmId").toString());
        IPage<SysCameraBrand> list = page(new Page<>(current, size), new QueryWrapper<SysCameraBrand>().like(StringUtils.isNotBlank(brandName), "brand_name", brandName).eq("farm_id", farmId));
        return new Result(ResultCode.SUCCESS, list);
    }

    @Override
    public Result removeIds(List<Integer> ids,String farmId) {
        for (Integer id : ids) {
            Integer integer = cameraMapper.selectCount(new QueryWrapper<SysCamera>().eq("brand_id", id).eq("farm_id",farmId));
            SysCameraBrand byId = this.getById(id);
            if (integer != 0) {
                return new Result(ResultCode.FAIL, "有" + byId.getBrandName() + "的摄像头在使用,删除失败");
            }
        }
        this.removeByIds(ids);
        return new Result(ResultCode.SUCCESS, "删除成功");
    }

}
