package com.huimv.guowei.admin.timer;

import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.entity.FootRawData;
import com.huimv.guowei.admin.group.entity.GroupAdvise;
import com.huimv.guowei.admin.group.entity.GroupDuckInfo;
import com.huimv.guowei.admin.group.entity.GroupThreshold;
import com.huimv.guowei.admin.group.service.IGroupAdviseService;
import com.huimv.guowei.admin.group.service.IGroupDuckInfoService;
import com.huimv.guowei.admin.group.service.IGroupThresholdService;
import com.huimv.guowei.admin.service.IFootRawDataService;
import org.apache.xmlbeans.impl.xb.xsdschema.All;
import org.checkerframework.checker.units.qual.A;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;

@Component
@EnableScheduling
public class FootTimer {

    @Autowired
    private IGroupThresholdService thresholdService;
    @Autowired
    private IFootRawDataService footRawDataService;
    @Autowired
    private IGroupAdviseService groupAdviseService;
    @Autowired
    private IGroupDuckInfoService duckInfoService;


    @Scheduled(cron = "0 */5 * * * ?")
    private void saveOnlineDevice(){
        GroupThreshold groupThreshold = thresholdService.getById(1);
        List<GroupDuckInfo> duckInfoList = duckInfoService.list(new QueryWrapper<GroupDuckInfo>().eq("is_leave", 0));
        for (GroupDuckInfo groupDuckInfo : duckInfoList) {
            String deviceCode = groupDuckInfo.getDeviceCode();
            int epc = footRawDataService.count(new QueryWrapper<FootRawData>().eq("epc", deviceCode).ge("date_time", DateUtil.offsetHour(new Date(),-(Integer.parseInt(groupThreshold.getTimes())))));
            if (epc == 0 ){
                GroupAdvise advise = new GroupAdvise();
                advise.setBatchNum(groupDuckInfo.getBatchNum());
                advise.setCreateTime(new Date());
                advise.setDeviceCode(groupDuckInfo.getDeviceCode());
                advise.setFarmId(groupDuckInfo.getFarmId());
                advise.setType(1);
                advise.setUnitId(groupDuckInfo.getUnitId());
                advise.setUnitName(groupDuckInfo.getUnitName());
                advise.setVersion("长时间未读取到脚环信息");
                groupAdviseService.save(advise);
            }
        }
    }

}
