package com.huimv.guowei.admin.timer;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.io.resource.ClassPathResource;
import cn.hutool.core.lang.Console;
import cn.hutool.core.text.csv.*;
import cn.hutool.core.util.CharsetUtil;
import cn.hutool.poi.excel.ExcelReader;
import cn.hutool.poi.excel.ExcelUtil;

import java.io.File;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.guowei.admin.timer
 * @Description : TODO
 * @Author : yuxuexuan
 * @Create : 2024-10-31 17:55
 **/
public class Test {
//    public static void main(String[] args) {
//        int[] ints = new int[]{231,223,1,2,132,1324,321,561,3};
//        Filter filter = new Filter(ints,2,2,1);
//        int[] data = filter.getData();
//        for (int datum : data) {
//            System.out.println(datum);
//        }
//
//    }
public static void main(String[] args) throws IOException {

    String floderName = "997.5";
//    String floderName = "1006";
//    String floderName = "2011_2010.5";
//    String floderName = "2983.5";
//    String floderName = "3003";
//    String floderName = "3003.5";
    String folderPath = "E:\\微信文件\\WeChat Files\\wxid_amis4cr3v84x22\\FileStorage\\File\\2024-10\\电子秤采样数据\\"+floderName;

    // 创建File对象表示文件夹
    File folder = new File(folderPath);

    // 检查该路径是否为一个文件夹
    if (folder.isDirectory()) {
        // 获取文件夹下的所有文件和子文件夹
        File[] files = folder.listFiles();

        if (files != null) {
            // 遍历文件和子文件夹
            for (File file : files) {
                //是文件就计算
                if (file.isFile()) {
                    String fileName  =  file.getName();
                    witerCsv(floderName,fileName);
                    System.out.println(file.getName());
                }
                // 如果你也想打印子文件夹中的文件，可以在这里添加递归调用
            }
        } else {
            System.out.println("该文件夹是空的或者无法读取内容。");
        }
    } else {
        System.out.println("指定的路径不是一个文件夹。");
    }

}

    private static void witerCsv(String folderName,String fileName) throws IOException {
        String inputCsvFilePath = "E:\\微信文件\\WeChat Files\\wxid_amis4cr3v84x22\\FileStorage\\File\\2024-10\\电子秤采样数据\\"+folderName+"\\"+fileName;
        // 输出CSV文件路径
        String outputCsvFilePath = "E:\\微信文件\\WeChat Files\\wxid_amis4cr3v84x22\\FileStorage\\File\\2024-10\\电子秤采样数据\\"+folderName+"\\test\\"+fileName;

        // 读取CSV文件

        CsvReader reader = CsvUtil.getReader();
        //从文件中读取CSV数据
        CsvData data = reader.read(FileUtil.file(inputCsvFilePath));
        List<CsvRow> rows = data.getRows();
        reader.close();

        // 提取double值并乘以100，转换为int数组
        List<Integer> intList = new ArrayList<>();
        for (List<String> row : rows) {
            // 每行的第一个元素是double值
            try {
                double doubleValue = Double.parseDouble(row.get(0));
                int intValue = (int) (doubleValue * 100);
                intList.add(intValue);
            }catch (NumberFormatException e){
                System.out.println("跳过不能转换为double的字符串: " + row.get(0));
            }

        }

        // 转换为int数组
        int[] processedIntArray = intList.stream().mapToInt(Integer::intValue).toArray();
        Filter filter = new Filter(processedIntArray,10000,10,200);
        int[] ints = filter.getData();
        // 写入处理后的数据到CSV文件
        CsvWriter writer = CsvUtil.getWriter(FileUtil.file(outputCsvFilePath), CharsetUtil.CHARSET_UTF_8);
        for (int i = 0; i < ints.length; i++) {

            double processedValue = ints[i] / 100.0;
            writer.write(CollUtil.newArrayList(String.format("%.2f", processedValue)));

        }

        writer.close();

        Console.log("处理完成，结果已写入到输出CSV文件中。");
    }

}
