package com.huimv.input.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author author
 * @since 2023-06-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("base_duck_info")
public class BaseDuckInfo implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    private String duckNum;

    /**
     * 1北京鸭、2连城白鸭、3山麻鸭、4攸县麻鸭、5白改鸭、6缙云麻鸭、7绍兴鸭(带圈白翼梢)、8绍兴鸭(红毛绿翼梢)、9绍兴鸭(白羽绍鸭)
     */
    private Integer duckBreed;

    /**
     * 0雄性，1雌性
     */
    private Integer duckSex;

    /**
     * 出生地
     */
    private String duckBirthplace;

    /**
     * 出生日期
     */
    private LocalDateTime duckBirthday;

    /**
     * 基因型
     */
    private String genotype;

    /**
     * 当前体重
     */
    private BigDecimal nowWeight;

    /**
     * 位置 id
     */
    private Integer unitId;

    /**
     * 位置
     */
    private String unitName;

    /**
     * 饲养环境
     */
    private String breedingEnv;

    /**
     * 出壳率
     */
    private BigDecimal hatchRate;

    /**
     * 日龄
     */
    private Integer dayAge;

    /**
     * 母系信息
     */
    private String motherNum;

    /**
     * 母亲基因型
     */
    private String motherGenotype;

    /**
     * 父系信息
     */
    private String fatherNum;

    /**
     * 父亲基因型
     */
    private String fatherGenotype;

    /**
     * 鸭子图片
     */
    private String duckImgUrl;

    /**
     * 特殊需求
     */
    private String specialNeeds;

    /**
     * 0未出笼 1已出笼
     */
    private Integer isCage;

    private Integer farmId;

    /**
     * 上下级位置id
     */
    private String unitList;
    private String chiNum;
    private String jiaoNum;
    private String batchNum;


}
