package com.huimv.input.send;

import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

@Component
public class ConfigSendingScheduler {

    private final DeviceConfigSender deviceConfigSender;

    public ConfigSendingScheduler(DeviceConfigSender deviceConfigSender) {
        this.deviceConfigSender = deviceConfigSender;
    }

    @Scheduled(cron = "0 * 1-2 * * ?")
    public void sendConfigPeriodically() {
        String deviceIpAddress = "设备IP地址";
        int devicePort = 12345;
        String configData = "要发送的配置数据";
        
        // 调用DeviceConfigSender的方法发送配置
        deviceConfigSender.sendConfigToDevice(deviceIpAddress, devicePort, configData);
    }
}
