package com.huimv.input.send;

import io.netty.bootstrap.Bootstrap;
import io.netty.channel.*;
import io.netty.channel.nio.NioEventLoopGroup;
import io.netty.channel.socket.SocketChannel;
import io.netty.channel.socket.nio.NioSocketChannel;
import org.springframework.stereotype.Component;

@Component
public class DeviceConfigSender {

    public void sendConfigToDevice(String deviceIpAddress, int devicePort, String configData) {
        EventLoopGroup group = new NioEventLoopGroup();
        try {
            Bootstrap bootstrap = new Bootstrap()
                    .group(group)
                    .channel(NioSocketChannel.class)
                    .option(ChannelOption.TCP_NODELAY, true)
                    .handler(new ChannelInitializer<SocketChannel>() {
                        @Override
                        protected void initChannel(SocketChannel ch) throws Exception {
                            ChannelPipeline pipeline = ch.pipeline();
                            // 在这里添加你的编码器和解码器
                            // pipeline.addLast(new YourEncoder());
                            // pipeline.addLast(new YourDecoder());
                            pipeline.addLast(new ConfigSenderHandler(configData));
                        }
                    });

            ChannelFuture future = bootstrap.connect(deviceIpAddress, devicePort).sync();
            future.channel().closeFuture().sync();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            group.shutdownGracefully();
        }
    }
}
