package com.huimv.input.server;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.input.entity.*;
import com.huimv.input.mapper.*;
import com.huimv.input.send.DeviceConfigSender;
import com.huimv.input.utils.ModBusUtils;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.*;
import io.netty.handler.codec.LengthFieldBasedFrameDecoder;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import javax.lang.model.element.VariableElement;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.nio.channels.SocketChannel;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.ZoneOffset;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.stream.Collectors;


/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@ChannelHandler.Sharable
@Component
@Slf4j
public class EnvInputServerHandler extends ChannelInboundHandlerAdapter   {
    private StringBuilder askTextSb = null;

    @Autowired
    private RawDataMapper rawDataMapper;

    @Autowired
    private EnvRegularCallEggMapper envRegularCallEggMapper;


    @Autowired
    private EnvDeviceMapper envDeviceMapper;

    @Autowired
    private BaseDuckInfoMapper baseDuckInfoMapper;
    @Autowired
    private DeviceFarmConfigMapper farmConfigMapper;

    @Autowired
    private EggProductionMapper eggProductionMapper;

    private static String  str = "";

    //
    public void appendClientAsk(String text) {
        if (this.askTextSb == null) {
            askTextSb = new StringBuilder();
        }
        askTextSb.append(text);
    }



    public static void main(String[] args) {

        String str =
    "55 86 57 00 49 00 01 4F 00 78 C5 09 C4 09 C4 09 C5 09 C4 09 C6 09 C5 09 C5 09 C6 09 C4 09 C5 09 C4 09 C5 09 C5 09 C5 09 C4 09 C3 09 C5 09 C4 09 C4 09 C4 09 C3 09 C5 09 C5 09 C4 09 C4 09 C4 09 C5 09 C4 09 C4 09 C5 09 C5 09 C5 09 C5 09 C4 09 C4 09 C4 09 C4 09 C4 09 C4 09 C4 09 C5 09 C4 09 C3 09 C3 09 C4 09 C5 09 C5 09 C3 09 C5 09 C5 09 C4 09 C5 09 C1 09 C4 09 C4 09 C3 09 C3 09 C3 09 C5 09 18 01 1D 09 19 08 AA ";
                String[] s = str.split(" ");
        String  dateTimeString = "2023-12-07 23:22:54";
        // 创建 DateTimeFormatter 对象，指定日期时间格式
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");

        // 将字符串解析为 LocalDateTime 对象
        LocalDateTime dateTime = LocalDateTime.parse(dateTimeString, formatter);

        // 获取时间戳（以秒为单位）
        long timestamp = dateTime.toEpochSecond(ZoneOffset.of("+8"));

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        System.out.println(timestamp);

        for (int i = 0; i < 60; i++) {

            long l = timestamp - ((60 - i) * 5 * 60); // 修正此行
            Date thenTime = new Date(l * 1000); // 将秒转换为毫秒
            String str1 = s[i * 2 + 11] + s[i * 2 + 10];
            BigDecimal weight = new BigDecimal(Integer.parseInt(str1, 16));
            System.out.println("" +  sdf.format(thenTime)+"  重量：" +weight  );
            Integer multiply = weight.multiply(BigDecimal.valueOf(1.0274)).intValue();
            System.out.println("计算后重量:"+ multiply);
            // 将 BigInteger 转换为 16 进制 String
            String s1 = Integer.toHexString(multiply);
            System.out.println("转换后"+s1);
            s[i * 2 + 11] = s1.substring(0,2);
            s[i * 2 + 10] = s1.substring(s1.length() - 2, s1.length());
        }
        String result = String.join(" ", s);
        System.out.println(result);
    }

    public String  replace(String str, double ratio){
        String[] s = str.split(" ");
        for (int i = 0; i < 60; i++) {
            String str1 = s[i * 2 + 11] + s[i * 2 + 10];
            BigDecimal weight = new BigDecimal(Integer.parseInt(str1, 16));
            Integer multiply = weight.multiply(BigDecimal.valueOf(ratio)).intValue();
            // 将 BigInteger 转换为 16 进制 String
            String s1 = Integer.toHexString(multiply);
            for (int j = s1.length(); j < 4; j++){
                s1 = "0"+s1;
            }
            s[i * 2 + 11] = s1.substring(0,2);
            s[i * 2 + 10] = s1.substring(s1.length() - 2, s1.length());
            System.out.println(s[i * 2 + 11]);
            System.out.println(s[i * 2 + 10]);
        }
        String result = String.join(" ", s);
        return result;
    }


    @Override
    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
//        if (msg instanceof ByteBuf) {
            ByteBuf byteBuf = (ByteBuf) msg;
            byte[] bytes = new byte[byteBuf.readableBytes()];
            byteBuf.readBytes(bytes);
             str += ModBusUtils.bytes2HexString(bytes);
            int length = str.length();
        if (length != 18 && length != 24 && length <411){
            return;
        }
        if (length > 411){
            str = "";
            return;
        }

            System.out.println("收到的数据：" + str + "   " + length  );
            if (length > 300) {
                saveWeight(str, bytes);
            } else if (length == 24) {
                String[] s = str.split(" ");
                String hexId = s[5] + s[4] + s[3] + s[2];
                System.out.println("十六进制id" + hexId);
                int decId = Integer.parseInt(hexId, 16);
                System.out.println("十进制id" + decId);
                EnvDevice envDevice = envDeviceMapper.selectOne(new QueryWrapper<EnvDevice>().eq("device_code", decId));

                if (ObjectUtil.isNotEmpty(envDevice)) {
                    List<DeviceFarmConfig> farm_id = farmConfigMapper.selectList(new QueryWrapper<DeviceFarmConfig>().eq("farm_id", envDevice.getFarmId()));
                    if (ObjectUtil.isNotEmpty(farm_id)) {
                        String timestr = farm_id.stream()
                                .map(config -> String.format("%02X%02X", config.getStartHour(), config.getEndHour()))
                                .collect(Collectors.joining());
                        ctx.writeAndFlush(Unpooled.copiedBuffer(hexStringToByteArray("550B02" + getDateX() + timestr + "AA")));
                    }
                    if (envDevice.getDeviceStatus() != 1) {
                        envDevice.setDeviceStatus(1);
                        envDeviceMapper.updateById(envDevice);
                    }
                } else {
                    List<DeviceFarmConfig> farm_id = farmConfigMapper.selectList(new QueryWrapper<DeviceFarmConfig>().eq("farm_id", 21));
                    if (ObjectUtil.isNotEmpty(farm_id)) {
                        String timestr = farm_id.stream()
                                .map(config -> String.format("%02X%02X", config.getStartHour(), config.getEndHour()))
                                .collect(Collectors.joining());
                        ctx.writeAndFlush(Unpooled.copiedBuffer(hexStringToByteArray("550B02" + getDateX() + timestr + "AA")));
                    }
                }

            } else {
                List<DeviceFarmConfig> farm_id = farmConfigMapper.selectList(new QueryWrapper<DeviceFarmConfig>().like("device_id", str));
                if (ObjectUtil.isNotEmpty(farm_id)) {
                    String timestr = farm_id.stream()
                            .map(config -> String.format("%02X%02X", config.getStartHour(), config.getEndHour()))
                            .collect(Collectors.joining());
                    String str1 = "550B02" + getDateX() + timestr + "AA";
//                for (int i = 0; i < 10; i++) {

                    LocalTime now = LocalTime.now();
                    LocalTime zero = LocalTime.of(0, 45);
                    LocalTime one = LocalTime.of(1, 5);
                    if (now.isAfter(zero) && now.isBefore(one)) {
                        for (int i = 0; i < 120; i++) {
                            ctx.writeAndFlush(Unpooled.copiedBuffer(hexStringToByteArray(str1)));
                            Thread.sleep(2000);
                        }
                    }

//                    System.out.println(i+" : 下发数据："+str1);
//                    Thread.sleep(3000);
                }

            }

//        }
       str = "";
            System.out.println("保存成功");
//        }else {
//            System.err.println("Unexpected message type: " + msg.getClass().getName());
//        }
    }



    private static byte[] hexStringToByteArray(String hexString) {
        int len = hexString.length();
        byte[] dataBytes = new byte[len / 2];

        for (int i = 0; i < len; i += 2) {
            dataBytes[i / 2] = (byte) ((Character.digit(hexString.charAt(i), 16) << 4)
                    + Character.digit(hexString.charAt(i + 1), 16));
        }

        return dataBytes;
    }


    public  String getDateX() {
        Date date = new Date();
        StringBuilder hexDateTimeBuilder = new StringBuilder();

        hexDateTimeBuilder.append(String.format("%02X", DateUtil.year(date) - 2000))
                .append(String.format("%02X", DateUtil.month(date) + 1))
                .append(String.format("%02X", DateUtil.dayOfMonth(date)))
                .append(String.format("%02X", DateUtil.hour(date, true)))
                .append(String.format("%02X", DateUtil.minute(date)))
                .append(String.format("%02X", DateUtil.second(date)));

//        String hexDateTime =
//        System.out.println(hexDateTime);
        return  hexDateTimeBuilder.toString();
    }




    public synchronized void saveWeight(String str, byte[] bytes) {
        String[] s = str.split(" ");
        String hexId = s[5] + s[4] + s[3] + s[2] ;
        System.out.println("十六进制id"+hexId);
        int decId = Integer.parseInt(hexId, 16);
        System.out.println("十进制id"+decId);
        long l = System.currentTimeMillis();
        double ratio = 1;
        BigDecimal bigDecimal10 = new BigDecimal(10);
        String bat = s[8] + s[7] ;
        String batStr = new BigDecimal(Integer.parseInt(bat, 16)).divide(bigDecimal10, 1, BigDecimal.ROUND_HALF_UP).toString();


        //获取上次一次数据
        RawData lastRawData = rawDataMapper.selectOne(new QueryWrapper<RawData>().eq("device_code", decId).orderByDesc("id").last("limit 1"));
        if (ObjectUtil.isNotEmpty(lastRawData) && str.equals(lastRawData.getData())){
            //相同数据直接退出
            System.out.println("相同数据直接退出");
            return;
        }
        BigDecimal lastWeight =  new BigDecimal(0);
        if (ObjectUtil.isNotEmpty(lastRawData)){
            lastWeight = lastRawData.getLastWeight();
        }
        int sLength = s.length;

        //获取设备
        EnvDevice envDevice = envDeviceMapper.selectOne(new QueryWrapper<EnvDevice>().eq("device_code", decId).eq("device_type", 3));
        if (ObjectUtil.isNotEmpty(envDevice)){
            if (ObjectUtil.isNotEmpty(envDevice.getRatio())){
                ratio = envDevice.getRatio();
            }
        }

        //保存原始数据
        RawData rawData = new RawData();
        rawData.setDeviceCode(decId+"");
//        rawData.setOriginData(str);
//        String replace = replace(str, ratio);
        rawData.setData(str);
//        rawData.setData(replace);
//        s = replace.split(" ");
        rawData.setCreateTime(new Date(l));
        rawData.setLastWeight(new BigDecimal(Integer.parseInt(s[sLength -8]+s[sLength-9], 16)));
        rawData.setBattery(batStr);
        int year = Integer.parseInt(s[s.length - 7], 16);
        int month = Integer.parseInt(s[s.length - 6], 16);
        int day = Integer.parseInt(s[s.length - 5], 16);
        int hour = Integer.parseInt(s[s.length - 4], 16);
        int minut = Integer.parseInt(s[s.length - 3], 16);
        int sco = Integer.parseInt(s[s.length - 2], 16);

        rawData.setLastTime(
                year +"-" +
                        month+"-"+
                        day+" "+
                        hour+":" +
                        minut+":" +
                        sco);
        rawDataMapper.insert(rawData);
        if(year>30 || year<10){
            return;
        }

        //获取设备
        if (ObjectUtil.isEmpty(envDevice)){
            System.out.println("固定电子称不存在，数据抛弃");
            return;
        }

        //获取鸭子
        Integer unitId = envDevice.getUnitId();
        BaseDuckInfo baseDuckInfo = baseDuckInfoMapper.selectOne(new QueryWrapper<BaseDuckInfo>().eq("unit_id", unitId).eq("is_cage", 0));
        if (ObjectUtil.isEmpty(baseDuckInfo)){
            System.out.println("该位置不存在鸭子，数据抛弃");
            return;
        }
        if (baseDuckInfo.getDuckSex() ==0){
            System.out.println("该位置为雄鸭，数据抛弃");
            return;
        }
        List<EggProduction> farm_id = eggProductionMapper.selectList(new QueryWrapper<EggProduction>().eq("farm_id", envDevice.getFarmId()));


        LocalTime jianStartTime = LocalTime.of(7, 30);    // 开始时间
        LocalTime jianEndTime = LocalTime.of(8, 30);     // 结束时间

        LocalTime liaoStartTime = LocalTime.of(6, 0);    // 开始时间
        LocalTime liaoEndTime = LocalTime.of(7, 29);     // 结束时间



        if(ObjectUtil.isNotEmpty(farm_id)){
            for (EggProduction eggProduction : farm_id) {
                if (eggProduction.getEventType() == 0){
                    //检蛋
                     jianStartTime = eggProduction.getStartTime();
                     jianEndTime = eggProduction.getEndTime();
                }else {
                    //上料
                     liaoStartTime = eggProduction.getStartTime();
                     liaoEndTime = eggProduction.getEndTime();
                }
            }
        }

        BigDecimal bigDecimal3 = new BigDecimal(3);
        BigDecimal bigDecimala3 = new BigDecimal(-3);
        BigDecimal bigDecimal0 = new BigDecimal(0);

        BigDecimal bigDecimal800 = new BigDecimal(-800);
//        BigDecimal bigDecimal2 = new BigDecimal(2);
        LocalTime currentTime = LocalTime.now();
        BigDecimal minWeight = new BigDecimal(99999);
        //检蛋
        if(currentTime.isAfter(jianStartTime) && currentTime.isBefore(jianEndTime)){
            List<EnvRegularCallEgg> callEgg = envRegularCallEggMapper.selectList(new QueryWrapper<EnvRegularCallEgg>().eq("call_code",decId).ge("call_date", DateUtil.beginOfDay(new Date())));
            if (ObjectUtil.isNotEmpty(callEgg) ){
                System.out.println(callEgg);
                return;
            }

            Integer eggCountNum =0;
            for (int i = 0; i < 60; i++) {
                String str1 = s[i * 2 + 11] + s[i * 2 + 10];
                BigDecimal weight = new BigDecimal(Integer.parseInt(str1, 16));
                int i2 = weight.intValue();
                if (i2 <2000){
                    continue;
                }
//                BigDecimal subtract = lastWeight.subtract(weight);
                BigDecimal subtract = weight.subtract(lastWeight);
                int i1 = subtract.intValue();

                if(i1>500&&ObjectUtil.isNotEmpty(callEgg)  && callEgg.size() <2) {

                    if (eggCountNum >2){
                        continue;
                    }
                    EnvRegularCallEgg envRegularCallEgg = new EnvRegularCallEgg();
                    envRegularCallEgg.setBattery(bat);
                    envRegularCallEgg.setCallDate(new Date());
                    envRegularCallEgg.setCallCode(decId + "");
                    envRegularCallEgg.setCallName(envDevice.getDeviceName());
                    envRegularCallEgg.setDuckId(baseDuckInfo.getId());
                    envRegularCallEgg.setDuckNum(baseDuckInfo.getDuckNum());
                    envRegularCallEgg.setFarmId(baseDuckInfo.getFarmId());
                    envRegularCallEgg.setUnitId(baseDuckInfo.getUnitId());
                    envRegularCallEgg.setUnitName(baseDuckInfo.getUnitName());
                    envRegularCallEgg.setChiNum(baseDuckInfo.getChiNum());
                    envRegularCallEgg.setJiaoNum(baseDuckInfo.getJiaoNum());
                    envRegularCallEgg.setBatchNum(baseDuckInfo.getBatchNum());
                    if (  i1 <1000) {
                        eggCountNum+=1;
                        envRegularCallEgg.setEggNum(1);
                    } else if (i1 >1400 && i1 <2000 ) {
                        eggCountNum +=2;
                        envRegularCallEgg.setEggNum(2);
                     }else {
                        continue;
                    }
                    if (weight.compareTo(bigDecimal0) == 0) {
                        envRegularCallEgg.setDuckFeedingOriginal(bigDecimal0);
                    } else {
                        envRegularCallEgg.setDuckFeedingOriginal(weight.divide(bigDecimal10, 1, BigDecimal.ROUND_HALF_UP));
                    }
                    if (subtract.compareTo(bigDecimal0) == 0) {
                        envRegularCallEgg.setDuckWeight(bigDecimal0);
                    } else {
                        BigDecimal divide = subtract.divide(bigDecimal10, 1, BigDecimal.ROUND_HALF_UP);
                        envRegularCallEgg.setDuckWeight(divide);
                    }
                    envRegularCallEggMapper.insert(envRegularCallEgg);

                }
                if(weight.compareTo(minWeight) <0){
                    minWeight = weight;
                }
                lastWeight = weight;
            }

//            //吃料
//            EnvRegularCallFeeding envRegularCallFeeding = new EnvRegularCallFeeding();
//            envRegularCallFeeding.setBattery(batStr);
//            envRegularCallFeeding.setCallDate(new Date());
//            envRegularCallFeeding.setCallCode(decId+"");
//            envRegularCallFeeding.setCallName(envDevice.getDeviceName());
//            envRegularCallFeeding.setDuckId(baseDuckInfo.getId());
//            envRegularCallFeeding.setDuckNum(baseDuckInfo.getDuckNum());
//            envRegularCallFeeding.setFarmId(baseDuckInfo.getFarmId());
//            envRegularCallFeeding.setUnitId(baseDuckInfo.getUnitId());
//            envRegularCallFeeding.setUnitName(baseDuckInfo.getUnitName());
//            envRegularCallFeeding.setChiNum(baseDuckInfo.getChiNum());
//            envRegularCallFeeding.setJiaoNum(baseDuckInfo.getJiaoNum());
//            envRegularCallFeeding.setBatchNum(baseDuckInfo.getBatchNum());
//            if (minWeight.compareTo(bigDecimal0 )==0){
//                envRegularCallFeeding.setDuckFeedingOriginal(bigDecimal0);
//            }else {
//                envRegularCallFeeding.setDuckFeedingOriginal(minWeight.divide(bigDecimal10, 1, BigDecimal.ROUND_HALF_UP) );
//            }
//            BigDecimal subtract = lastWeight.subtract(minWeight);
//            BigDecimal divide = subtract.divide(bigDecimal10, 1, BigDecimal.ROUND_HALF_UP);
//            if (subtract.compareTo(bigDecimal0 )==0){
//                envRegularCallFeeding.setDuckWeight(bigDecimal0);
//            }else  if(divide.compareTo(new BigDecimal(500 ) )> 0 ){
//                return;
//            }else {
//                envRegularCallFeeding.setDuckWeight( divide);
//            }
//            rawData.setLastWeight(minWeight);
//            rawDataMapper.updateById(rawData);


        }

        //上料
     /*else  if(currentTime.isAfter(liaoStartTime) && currentTime.isBefore(liaoEndTime)){
            BigDecimal lastWeight2 = lastWeight;
            BigDecimal maxWeight = null;
            for (int i = 0; i < 60; i++) {
                String str1 = s[i * 2 + 11] + s[i * 2 + 10];
                BigDecimal weight = new BigDecimal(Integer.parseInt(str1,16));
                int i2 = weight.intValue();
                if (i2 <2000){
                    continue;
                }
               BigDecimal subtract = lastWeight.subtract(weight);
                int i1 = subtract.intValue();
                if(weight.compareTo(minWeight) <0 && -800<i1&& i1<800){
                    minWeight = weight;
                }

                if(i1 <-3000){
                    //加料
                     maxWeight = weight;
                    EnvRegularCallFeedingCopy envRegularCallFeedingCopy = new EnvRegularCallFeedingCopy();
                    envRegularCallFeedingCopy.setBattery(new BigDecimal(Integer.parseInt(bat, 16)).divide(bigDecimal10, 1, BigDecimal.ROUND_HALF_UP).toString());
                    envRegularCallFeedingCopy.setCallDate(new Date());
                    envRegularCallFeedingCopy.setCallCode(decId+"");
                    envRegularCallFeedingCopy.setCallName(envDevice.getDeviceName());
                    envRegularCallFeedingCopy.setDuckId(baseDuckInfo.getId());
                    envRegularCallFeedingCopy.setDuckNum(baseDuckInfo.getDuckNum());
                    envRegularCallFeedingCopy.setFarmId(baseDuckInfo.getFarmId());
                    envRegularCallFeedingCopy.setUnitId(baseDuckInfo.getUnitId());
                    envRegularCallFeedingCopy.setUnitName(baseDuckInfo.getUnitName());
                    if (weight.compareTo(bigDecimal0)==0){
                        envRegularCallFeedingCopy.setDuckFeedingOriginal(bigDecimal0);
                    }else {
                        envRegularCallFeedingCopy.setDuckFeedingOriginal(weight.divide(bigDecimal10, 1, BigDecimal.ROUND_HALF_UP) );
                    }
                    if (subtract.compareTo(bigDecimal0 )==0){
                        envRegularCallFeedingCopy.setDuckWeight(bigDecimal0);
                    }else {
                        envRegularCallFeedingCopy.setDuckWeight(subtract.divide(bigDecimal10, 1, BigDecimal.ROUND_HALF_UP) );
                    }

                    envRegularCallFeedingCopy.setEventType(1);
                    envRegularCallFeedingCopyMapper.insert(envRegularCallFeedingCopy);
                    lastWeight =weight;
                    continue;
                }
                lastWeight = weight;
            }
            EnvRegularCallFeeding envRegularCallFeeding = new EnvRegularCallFeeding();
            envRegularCallFeeding.setBattery(batStr);
            envRegularCallFeeding.setCallDate(new Date());
            envRegularCallFeeding.setCallCode(decId+"");
            envRegularCallFeeding.setCallName(envDevice.getDeviceName());
            envRegularCallFeeding.setDuckId(baseDuckInfo.getId());
            envRegularCallFeeding.setDuckNum(baseDuckInfo.getDuckNum());
            envRegularCallFeeding.setFarmId(baseDuckInfo.getFarmId());
            envRegularCallFeeding.setUnitId(baseDuckInfo.getUnitId());
            envRegularCallFeeding.setChiNum(baseDuckInfo.getChiNum());
            envRegularCallFeeding.setJiaoNum(baseDuckInfo.getJiaoNum());
            envRegularCallFeeding.setBatchNum(baseDuckInfo.getBatchNum());
            envRegularCallFeeding.setUnitName(baseDuckInfo.getUnitName());

            if (lastWeight.compareTo(bigDecimal0 )==0){
                envRegularCallFeeding.setDuckFeedingOriginal(bigDecimal0);
            }else {
                envRegularCallFeeding.setDuckFeedingOriginal(lastWeight.divide(bigDecimal10, 1, BigDecimal.ROUND_HALF_UP) );
            }

            BigDecimal subtract = lastWeight2.subtract(minWeight);
            if (maxWeight!= null){
                BigDecimal subtract1 = maxWeight.subtract(lastWeight);
                subtract =     subtract.add(subtract1);
            }

            if (subtract.compareTo(bigDecimal0 )==0){
                envRegularCallFeeding.setDuckFeedingOriginal(bigDecimal0);
            }else {
                envRegularCallFeeding.setDuckWeight(subtract.divide(bigDecimal10, 1, BigDecimal.ROUND_HALF_UP) );
            }
            if (subtract.intValue()>0){
                envRegularCallFeedingMapper.insert(envRegularCallFeeding);
            }
            rawData.setLastWeight(lastWeight);
            rawDataMapper.updateById(rawData);
        }
     else {
//            BigDecimal minweight = lastWeight;
            for (int i = 0; i < 60; i++) {
                String str1 = s[i * 2 + 11] + s[i * 2 + 10];
                BigDecimal weight = new BigDecimal(Integer.parseInt(str1, 16));

                int i2 = weight.intValue();
                if (i2 <2000){
                    continue;
                }
                if (weight.compareTo(minWeight) <0) {
                    minWeight = weight;
                }
            }
            BigDecimal subtract = lastWeight.subtract(minWeight);
            if (subtract.compareTo(bigDecimal0)<0){
                System.out.println("波动小于0.3g，舍弃");
                return;
            }
            EnvRegularCallFeeding envRegularCallFeeding = new EnvRegularCallFeeding();
            envRegularCallFeeding.setBattery(batStr);
            envRegularCallFeeding.setCallDate(new Date());
            envRegularCallFeeding.setCallCode(decId+"");
            envRegularCallFeeding.setCallName(envDevice.getDeviceName());
            envRegularCallFeeding.setDuckId(baseDuckInfo.getId());
            envRegularCallFeeding.setDuckNum(baseDuckInfo.getDuckNum());
            envRegularCallFeeding.setFarmId(baseDuckInfo.getFarmId());
            envRegularCallFeeding.setUnitId(baseDuckInfo.getUnitId());
            envRegularCallFeeding.setUnitName(baseDuckInfo.getUnitName());
            envRegularCallFeeding.setChiNum(baseDuckInfo.getChiNum());
            envRegularCallFeeding.setJiaoNum(baseDuckInfo.getJiaoNum());
            envRegularCallFeeding.setBatchNum(baseDuckInfo.getBatchNum());
            if (minWeight.compareTo(bigDecimal0 )==0){
                envRegularCallFeeding.setDuckFeedingOriginal(bigDecimal0);
            }else {
                envRegularCallFeeding.setDuckFeedingOriginal(minWeight.divide(bigDecimal10, 1, BigDecimal.ROUND_HALF_UP) );
            }
            BigDecimal divide = subtract.divide(bigDecimal10, 1, BigDecimal.ROUND_HALF_UP);
            if (subtract.compareTo(bigDecimal0 )==0){
                envRegularCallFeeding.setDuckWeight(bigDecimal0);
            }else  if(divide.compareTo(new BigDecimal(500 ) )> 0 ){
                return;
             }else {
                envRegularCallFeeding.setDuckWeight( divide);
            }

            envRegularCallFeeding.setEventType(0);
            envRegularCallFeedingMapper.insert(envRegularCallFeeding);
            rawData.setLastWeight(minWeight);
            rawDataMapper.updateById(rawData);

        }*/

    }


    @Override
    public void channelReadComplete(ChannelHandlerContext ctx) throws Exception {

//        if (true){
//            ctx.writeAndFlush(Unpooled.copiedBuffer(new byte[]{1, 2, 3}));
//        }

//        if (askTextSb.toString().indexOf("end") != -1) {
//            // {处理客户端消息}


//            handleClientAskCmd(askTextSb.toString(), ctx);
//            //清空重置;
//            askTextSb.delete(0, askTextSb.length());
//        }
    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        if (cause.getMessage().indexOf("Connection reset") != -1) {
            log.info("相关采集器设备正在重启:" + cause.toString());
        }
//        cause.printStackTrace();
        ctx.close();
    }

    /**
     * @Method : handleClientAskCmd
     * @Description : 处理请求小心
     * @Params : [clientAskText, ctx]
     * @Return : void
     * @Author : ZhuoNing
     * @Date : 2022/3/28
     * @Time : 17:36
     */
    private void handleClientAskCmd(String clientAskText, ChannelHandlerContext ctx) throws ParseException, IOException {
        clientAskText = clientAskText.replaceAll("\r", "").replaceAll("\n", "");
        //{处理非正常命令}
//        int countPlus = regexUtil.countPlus(clientAskText);
//        if (countPlus < 4) {
//            System.out.println("当前数据为不完整数据，故丢弃.>>" + clientAskText);
//        } else {
        //--处理客户端请求数据
        //{拆分粘包数据}
        JSONArray askJa = parseAskCmdPackage(clientAskText);
        for (int a = 0; a < askJa.size(); a++) {
            String askText = askJa.getString(a);
            //{处理请求命令}
            askCmdActuator(askText, ctx);
        }
//        }
    }

    /**
     * @Method : askCmdActuator
     * @Description :
     * @Params : [askText, ctx]
     * @Return : void
     * @Author : ZhuoNing
     * @Date : 2022/3/23
     * @Time : 18:08
     */
    private void askCmdActuator(String askText, ChannelHandlerContext ctx) throws ParseException, IOException {
        System.out.println("======>接收设备请求:" + askText);
        String[] dataArray = askText.split("\\+");
        String cmdHeader = dataArray[0];
        if (!cmdHeader.trim().equalsIgnoreCase("hm")) {
            log.info("当前命令是非hm命令[" + askText + "]");
            return;
        }
        //芯片id/设备编码
        String idCode = dataArray[1];
        String cmd = dataArray[2];
        Map map = new HashMap();
        map.put("askText", askText);
        switch (cmd) {
            case "1":
                //获取远程设备编码
                getDeviceCode(askText, idCode, ctx);
                break;
            case "2":
                //同步时间
                getServerTime(askText, idCode, ctx);
                break;
            default:
                System.out.println("==>未知命令");
                log.error(">>当前数据为非法数据-未知命令>>" + askText);
        }
    }



    //时间同步请求
    private void getServerTime(String askText, String deviceCode, ChannelHandlerContext ctx) throws ParseException {
        System.out.println("==>时间同步请求:" + askText);
//        if (!cmdProService.isEffectiveDevice(deviceCode)) {
//            System.out.println("##时间同步请求-未注册设备 idCode=" + deviceCode);
//            return;
//        }
        String answerText = "hm+2+" + "+0+4+end";
//        log.info(">>时间同步请求-应答数据>>" + answerText);
        answerCmd(answerText, ctx);
    }

    //获取远程设备编码
    private void getDeviceCode(String askText, String idCode, ChannelHandlerContext ctx) {
        System.out.println("==>获取远程设备编码请求:" + askText.trim());
        //{读取设备编码}
//        String deviceCode = cmdProService.getDeviceCodeByChipId(idCode);
//        log.info("获取远程设备编码请求,芯片id>>" + idCode + " ,deviceCode>>" + deviceCode);
//        if (deviceCode == null) {
//            log.error("该设备未注册,已舍弃请求.");
//            return;
//        }
//        String answerText = "hm+1+0+" + deviceCode + "+123+8+end";
//        log.info("<<获取远程设备编码请求-应答数据:" + answerText);
        //{应答指令}
//        answerCmd(answerText, ctx);
    }

    //应答
    public void answerCmd(String answerText, ChannelHandlerContext ctx) {
        ctx.writeAndFlush(Unpooled.copiedBuffer(answerText.getBytes()));
    }

    //检查无效耳标
    public boolean checkValidEarmark(String earmark) {
        if (earmark.trim().equalsIgnoreCase("ffffffffffffffff") || earmark.trim().equalsIgnoreCase("0000000000000000")) {
            return true;
        } else {
            return false;
        }
    }

    //拆分粘包数据
    public JSONArray parseAskCmdPackage(String text) {
        String key = "end";
        Pattern pattern = Pattern.compile(key);
        Matcher matcher = pattern.matcher(text);
        int count = 0;
        while (matcher.find()) {
            count++;
        }
        JSONArray dataJa = new JSONArray();
        if (count == 1) {
            dataJa.add(text);
        } else {
            for (int a = 0; a < count; a++) {
                int p1 = text.indexOf("end");
                dataJa.add(text.substring(0, p1 + 3));
                text = text.substring(p1 + 3, text.length());
            }
        }
        return dataJa;
    }
}
