package com.huimv.input.server;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;

public class HexFrameDecoder extends SimpleChannelInboundHandler<ByteBuf> {

    private final int messageLength;

    public HexFrameDecoder(int messageLength) {
        this.messageLength = messageLength;
    }

    @Override
    protected void channelRead0(ChannelHandlerContext ctx, ByteBuf msg) throws Exception {
        if (msg.readableBytes() < messageLength) {
            // 不够长度，等待更多数据
            return;
        }

        // 读取固定长度的字节
        byte[] byteArray = new byte[messageLength];
        msg.readBytes(byteArray);

        // 在这里处理字节数组
        // ...

        // 继续处理下一个消息
        ctx.fireChannelRead(msg);
    }
}
