package com.huimv.input.server;

import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.ByteToMessageDecoder;
import io.netty.util.CharsetUtil;

import javax.xml.bind.DatatypeConverter;
import java.util.List;

public class MyFixedLengthDecoder extends ByteToMessageDecoder {

    private  int messageLength;

    public MyFixedLengthDecoder(int messageLength) {
        this.messageLength = messageLength;
    }

    @Override
    protected void decode(ChannelHandlerContext ctx, ByteBuf in, List<Object> out) throws Exception {
        // 确保有足够的可读字节
        if (in.readableBytes() < messageLength) {
            return;
        }

        // 读取固定长度的字节
        ByteBuf frame = in.readBytes(messageLength);
        System.out.println(messageLength);
        // 将读取的字节转换为十六进制字符串
        String hexString = frame.toString(CharsetUtil.UTF_8);

        // 将十六进制字符串转换为字节数组
        byte[] byteArray = DatatypeConverter.parseHexBinary(hexString);

        // 将字节数组添加到输出列表
        out.add(Unpooled.wrappedBuffer(byteArray));
    }


}
