package com.huimv.input;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.input.entity.RawData;
import com.huimv.input.mapper.RawDataMapper;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

@SpringBootTest
class InputApplicationTests {
    @Autowired
    private RawDataMapper rawDataMapper;

    @Test
    void contextLoads() {
        List<RawData> rawData = rawDataMapper.selectList(new QueryWrapper<RawData>().between("create_time", "2023-12-07 19:00:00", "2023-12-08 05:10:00")
                .eq("device_code", "4849698"));

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

        for (RawData rawDatum : rawData) {

            String str =rawDatum.getData();

            String[] s = str.split(" ");
            Date date = rawDatum.getCreateTime();

            long time = date.getTime();
            for (int i = 0; i < 60; i++) {

                long l = time - ((60 - i)* 1000 * 5 * 60); // 修正此行
                Date thenTime = new Date(l ); // 将秒转换为毫秒
                String str1 = s[i * 2 + 11] + s[i * 2 + 10];
                BigDecimal weight = new BigDecimal(Integer.parseInt(str1, 16));
                System.out.println("" +  sdf.format(thenTime)+"  重量：" +weight  );
            }
        }
    }

}
